--CONVERT
--밡 ĳͼ ȸ
SELECT *
FROM V$NLS_VALID_VALUES
WHERE PARAMETER = 'CHARACTERSET';

--ĳͼ 
SELECT CONVERT('New Word', 'KO16KSC5601', 'UTF8')
FROM DUAL;

SELECT LENGTHB(CONVERT('AAA', 'KO16KSC5601'))
FROM DUAL;

SELECT LENGTHB(CONVERT('AAA', 'UTF8'))
FROM DUAL;

SELECT LENGTHB(CONVERT('', 'KO16KSC5601'))
FROM DUAL;

SELECT LENGTHB(CONVERT('', 'UTF8'))
FROM DUAL;

SELECT LENGTHB(CONVERT('', 'US7ASCII'))
FROM DUAL;

SELECT CONVERT(CONVERT('', 'KO16KSC5601', 'UTF8'), 'UTF8')
FROM DUAL;

DROP TABLE TB_CONVERT;

CREATE TABLE TB_CONVERT (
    COL_NM    VARCHAR2(100),
    COL_TYPE  VARCHAR2(30)
);

INSERT INTO TB_CONVERT (COL_NM, COL_TYPE)
SELECT CONVERT('', 'KO16KSC5601', 'UTF8'),'KO16KSC5601' 
FROM DUAL;

INSERT INTO TB_CONVERT (COL_NM, COL_TYPE)
SELECT CONVERT('', 'UTF8', 'UTF8'),'UTF8' 
FROM DUAL;

COMMIT;

SELECT *
FROM TB_CONVERT
WHERE COL_TYPE = 'UTF8';

SELECT CONVERT(COL_NM, 'UTF8', 'KO16KSC5601')
FROM TB_CONVERT
WHERE COL_TYPE = 'KO16KSC5601';

SELECT CASE WHEN COL_TYPE = 'UTF8' THEN COL_NM ELSE CONVERT(COL_NM, 'UTF8', 'KO16KSC5601') END 
FROM TB_CONVERT;

--TO_CHAR
SELECT TO_CHAR(SYSDATE)
FROM DUAL;

SELECT TO_CHAR(SYSDATE, 'YYYY-MM-DD HH24:MI:SS')
FROM DUAL;

SELECT TO_CHAR(10000)
FROM DUAL;

SELECT TO_CHAR(10000, '999,999')
FROM DUAL;

--TO_DATE
SELECT TO_DATE('20131225')
FROM DUAL;

SELECT TO_DATE('20131225', 'YYYYMMDD')
FROM DUAL;


--TO_NUMBER
SELECT TO_NUMBER('100')
FROM DUAL;

CREATE TABLE TB_NUM_TEST (
    COL_NUM VARCHAR2(10)
);

INSERT INTO TB_NUM_TEST
SELECT LEVEL
FROM DUAL
CONNECT BY LEVEL < 15;

COMMIT;

SELECT *
FROM TB_NUM_TEST
ORDER BY COL_NUM;

SELECT *
FROM TB_NUM_TEST
ORDER BY TO_NUMBER(COL_NUM);

