--11.(view)
--1. 
-- 
CREATE OR REPLACE VIEW UV_TEST_01(
  JOB_ID UNIQUE RELY DISABLE NOVALIDATE,
  JOB_TITLE,
  MIN_SALARY
)
AS
SELECT JOB_ID, JOB_TITLE, MIN_SALARY
FROM HR.JOBS;

--  ߻
CREATE VIEW UV_TEST_02
AS
SELECT JOB_ID, JOB_TITLE, MIN_SALARY * 1.1
FROM HR.JOBS;

--  ߻ - 
CREATE FORCE VIEW UV_TEST_02
AS
SELECT JOB_ID, JOB_TITLE, MIN_SALARY * 1.1
FROM HR.JOBS;

-- ߻κ 
CREATE OR REPLACE VIEW UV_TEST_02
AS
SELECT JOB_ID, JOB_TITLE, MIN_SALARY * 1.1 AS NEXT_SALARY
FROM HR.JOBS;

--ٸ 並 ̿ 丸
CREATE VIEW UV_TEST_03 
AS
SELECT JOB_ID, JOB_TITLE, NEXT_SALARY
FROM UV_TEST_02;

--Ȯ
SELECT *
FROM UV_TEST_03;

--  
DROP VIEW UV_TEST_02;


-- ߻κ 
CREATE OR REPLACE VIEW UV_TEST_02
AS
SELECT JOB_ID, JOB_TITLE, MIN_SALARY * 1.1 AS NEXT_SALARY
FROM HR.JOBS;

-- 
ALTER VIEW UV_TEST_03 COMPILE;

--  
DROP VIEW UV_TEST_01;

DROP VIEW UV_TEST_02;

DROP VIEW UV_TEST_03;

--ζκ
SELECT a.FIRST_NAME, a.JOB_ID, a.SALARY, b.SALARY_SUM
FROM EMPLOYEES a, (SELECT JOB_ID, SUM(SALARY) AS SALARY_SUM
                     FROM EMPLOYEES
                    GROUP BY JOB_ID) b
WHERE a.JOB_ID = b.JOB_ID;

--2.  
--  ̺ 
CREATE TABLE TB_TEST_01 (
    KEY_01  VARCHAR2(10),
    KEY_02  VARCHAR2(10),
    COL_01  VARCHAR2(100),
    COL_02  VARCHAR2(100),
    CONSTRAINT PK_TEST_01 PRIMARY KEY (KEY_01, KEY_02)
);

-- Ȯ
SELECT *
FROM TB_TEST_01;

--ڷ Է ̺ ̿ ܼ 丸
CREATE OR REPLACE VIEW UV_TEST_01 (
    KEY_01,
    KEY_02,
    COL_01,
    CONSTRAINT PK_UV_TEST_01 PRIMARY KEY (KEY_01) DISABLE NOVALIDATE
)
AS
SELECT KEY_01, KEY_02, COL_01
FROM TB_TEST_01;

--ڷ Է
INSERT INTO UV_TEST_01(KEY_01, KEY_02, COL_01)
VALUES ('AAA', 'AAA', 'AAA');

--ڷ Է
INSERT INTO UV_TEST_01(KEY_01, KEY_02, COL_01)
VALUES ('AAA', 'BBB', 'AAA');

--ڷ Է
INSERT INTO UV_TEST_01(KEY_01, KEY_02, COL_01)
VALUES ('AAA', 'BBB', 'AAA');

COMMIT;

--ڷ Ȯ
SELECT *
FROM TB_TEST_01;

--ڷ
UPDATE UV_TEST_01 SET COL_01 = 'BBB'
WHERE KEY_01 = 'AAA'
AND KEY_02 = 'AAA';

COMMIT;

--ڷ Ȯ
SELECT *
FROM TB_TEST_01;

DELETE 
FROM UV_TEST_01
WHERE KEY_01 = 'AAA'
AND KEY_02 = 'AAA';

COMMIT;

--ڷ Ȯ
SELECT *
FROM TB_TEST_01;

-- Է (ɼ)
--READ ONLY
CREATE OR REPLACE VIEW UV_TEST_01
AS
SELECT KEY_01, KEY_02, COL_01
FROM TB_TEST_01
WITH READ ONLY;

--ڷ Է(Ȯ)
INSERT INTO UV_TEST_01(KEY_01, KEY_02, COL_01)
VALUES ('BBB', 'AAA', 'AAA');

--ڷ(Ȯ)
UPDATE UV_TEST_01 SET COL_01 = 'BBB'
WHERE KEY_01 = 'AAA'
AND KEY_02 = 'BBB';

--ڷ(Ȯ)
DELETE 
FROM UV_TEST_01
WHERE KEY_01 = 'AAA'
AND KEY_02 = 'BBB';

--WITH CHECK OPTION
CREATE OR REPLACE VIEW UV_TEST_01
AS
SELECT KEY_01, KEY_02, COL_01
FROM TB_TEST_01
WHERE COL_01 IN ('AAA', 'BBB')
WITH CHECK OPTION CONSTRAINT CHK_UV_TEST_01;

--ڷԷ
INSERT INTO UV_TEST_01(KEY_01, KEY_02, COL_01)
VALUES ('BBB', 'AAA', 'AAA');

INSERT INTO UV_TEST_01(KEY_01, KEY_02, COL_01)
VALUES ('BBB', 'BBB', 'BBB');

--Ȯ
INSERT INTO UV_TEST_01(KEY_01, KEY_02, COL_01)
VALUES ('BBB', 'BBB', 'CCC');

COMMIT;

SELECT *
FROM TB_TEST_01;

--ڷ(Ȯ)
UPDATE UV_TEST_01 SET COL_01 = 'AAA'
WHERE KEY_01 = 'BBB'
AND KEY_02 = 'BBB';

--Ȯ
UPDATE UV_TEST_01 SET COL_01 = 'CCC'
WHERE KEY_01 = 'BBB'
AND KEY_02 = 'BBB';

COMMIT;

--並 ̿   
--INTERSECT, MINUS, UNION, UNION ALL
CREATE OR REPLACE VIEW UV_TEST_01
AS
SELECT KEY_01, KEY_02, COL_01
FROM TB_TEST_01
UNION ALL
SELECT KEY_01, KEY_02, COL_01
FROM TB_TEST_01;

--Ȯ
INSERT INTO UV_TEST_01(KEY_01, KEY_02, COL_01)
VALUES ('CCC', 'CCC', 'CCC');

--DISTINCT ()
CREATE OR REPLACE VIEW UV_TEST_01
AS
SELECT DISTINCT KEY_01, KEY_02, COL_01
FROM TB_TEST_01;

--ƴ
INSERT INTO UV_TEST_01(KEY_01, KEY_02, COL_01)
VALUES ('CCC', 'DDD', 'CCC');

--̺ 
CREATE TABLE TB_TEST_02
AS
SELECT KEY_01, KEY_02, COL_01, COL_02
FROM TB_TEST_01;
 
--Ű   伱
CREATE OR REPLACE VIEW UV_TEST_02
AS
SELECT DISTINCT KEY_01, KEY_02, COL_01
FROM TB_TEST_02;

--Ȯ
INSERT INTO UV_TEST_02(KEY_01, KEY_02, COL_01)
VALUES ('AAAA', 'DDD', 'CCC');

--׷Լ
CREATE OR REPLACE VIEW UV_TEST_01
AS
SELECT KEY_01, KEY_02, MAX(COL_01) AS COL_01
FROM TB_TEST_01
GROUP BY KEY_01, KEY_02;

--÷ ̿ Է
INSERT INTO UV_TEST_01(KEY_01, KEY_02, COL_01)
VALUES ('AAAA', 'EEE', 'AAA');

--
INSERT INTO UV_TEST_01(KEY_01, KEY_02)
VALUES ('AAAA', 'DDD');

--CONNECT BY 
CREATE OR REPLACE VIEW UV_TEST_01
AS
SELECT KEY_01, KEY_02, COL_01
FROM TB_TEST_01
CONNECT BY KEY_01 = KEY_02;

--Ȯ
INSERT INTO UV_TEST_01(KEY_01, KEY_02, COL_01)
VALUES ('AAAA', 'FFF', 'AAA');

--JOIN
CREATE OR REPLACE VIEW UV_TEST_01
AS
SELECT A.KEY_01, A.KEY_02, A.COL_01
FROM TB_TEST_01 A, JOBS B
WHERE A.KEY_01 = B.JOB_ID
AND   A.KEY_02 = B.JOB_TITLE;

--ȳ
INSERT INTO UV_TEST_01(KEY_01, KEY_02, COL_01)
VALUES ('AAA', 'FFF', 'AAA');

--ճ
CREATE OR REPLACE VIEW UV_TEST_01
AS
SELECT A.KEY_01, A.KEY_02, A.COL_01, B.MAX_SALARY
FROM TB_TEST_01 A, JOBS B
WHERE A.KEY_01 = B.JOB_ID
AND   A.KEY_02 = B.JOB_TITLE;

--Ȯ
INSERT INTO UV_TEST_01(KEY_01, KEY_02, COL_01, MAX_SALARY)
VALUES ('AAA', 'FFF', 'AAA', 100);

COMMIT;