--ε 
--ε ڵ
--̺  
CREATE TABLE HR.TB_TEST_01 (
    KEY_01  VARCHAR2(10),
    KEY_02  VARCHAR2(10),
    COL_01  VARCHAR2(100),
    COL_02  VARCHAR2(100),
    CONSTRAINT PK_TB_TEST_01 PRIMARY KEY(KEY_01, KEY_02),
    CONSTRAINT UK_TB_TEST_01 UNIQUE (KEY_01)
);

--Ȯ
SELECT *
FROM ALL_INDEXES
WHERE INDEX_NAME IN ('PK_TB_TEST_01', 'UK_TB_TEST_01');

SELECT OWNER, CONSTRAINT_NAME, TABLE_NAME, INDEX_OWNER, INDEX_NAME  
FROM ALL_CONSTRAINTS
WHERE INDEX_NAME IN ('PK_TB_TEST_01', 'UK_TB_TEST_01');

--̺  ڵ
DROP TABLE HR.TB_TEST_01 PURGE;

--Ȯ
SELECT *
FROM ALL_INDEXES
WHERE INDEX_NAME IN ('PK_TB_TEST_01', 'UK_TB_TEST_01');

SELECT OWNER, CONSTRAINT_NAME, TABLE_NAME, INDEX_OWNER, INDEX_NAME  
FROM ALL_CONSTRAINTS
WHERE INDEX_NAME IN ('PK_TB_TEST_01', 'UK_TB_TEST_01');

--̺  
--̺ 
CREATE TABLE HR.TB_TEST_01 (
    KEY_01  VARCHAR2(10),
    KEY_02  VARCHAR2(10),
    COL_01  VARCHAR2(100),
    COL_02  VARCHAR2(100)
);

--̺  
ALTER TABLE HR.TB_TEST_01
ADD CONSTRAINT PK_TB_TEST_01 PRIMARY KEY(KEY_01, KEY_02)
ADD CONSTRAINT UK_TB_TEST_01 UNIQUE (KEY_01);

--Ȯ
SELECT *
FROM ALL_INDEXES
WHERE INDEX_NAME IN ('PK_TB_TEST_01', 'UK_TB_TEST_01');

SELECT OWNER, CONSTRAINT_NAME, TABLE_NAME, INDEX_OWNER, INDEX_NAME  
FROM ALL_CONSTRAINTS
WHERE INDEX_NAME IN ('PK_TB_TEST_01', 'UK_TB_TEST_01');

--  ڵ
ALTER TABLE HR.TB_TEST_01
DROP CONSTRAINT PK_TB_TEST_01
DROP CONSTRAINT UK_TB_TEST_01;

--Ȯ
SELECT *
FROM ALL_INDEXES
WHERE INDEX_NAME IN ('PK_TB_TEST_01', 'UK_TB_TEST_01');

SELECT OWNER, CONSTRAINT_NAME, TABLE_NAME, INDEX_OWNER, INDEX_NAME  
FROM ALL_CONSTRAINTS
WHERE INDEX_NAME IN ('PK_TB_TEST_01', 'UK_TB_TEST_01');

--  ε   
-- ε  (߿ )
CREATE INDEX HR.IDX_TB_TEST_01 ON HR.TB_TEST_01(KEY_01, KEY_02);

--Ȯ
SELECT *
FROM ALL_INDEXES
WHERE INDEX_NAME = 'IDX_TB_TEST_01';

SELECT OWNER, CONSTRAINT_NAME, TABLE_NAME, INDEX_OWNER, INDEX_NAME  
FROM ALL_CONSTRAINTS
WHERE INDEX_NAME = 'IDX_TB_TEST_01';

-- 
ALTER TABLE HR.TB_TEST_01
ADD CONSTRAINTS PK_TB_TEST_01 PRIMARY KEY(KEY_01, KEY_02);

--Ȯ
SELECT OWNER, CONSTRAINT_NAME, TABLE_NAME, INDEX_OWNER, INDEX_NAME  
FROM ALL_CONSTRAINTS
WHERE INDEX_NAME = 'IDX_TB_TEST_01';
 
--  
ALTER TABLE HR.TB_TEST_01
DROP CONSTRAINTS PK_TB_TEST_01;

--Ȯ(   ε  ȵ) 
SELECT *
FROM ALL_INDEXES
WHERE INDEX_NAME = 'IDX_TB_TEST_01';

SELECT OWNER, CONSTRAINT_NAME, TABLE_NAME, INDEX_OWNER, INDEX_NAME  
FROM ALL_CONSTRAINTS
WHERE INDEX_NAME = 'IDX_TB_TEST_01';

--ε    
--Ϲ() ε

--ε 
DROP INDEX HR.IDX_TB_TEST_01; 

-- Է
INSERT INTO HR.TB_TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('AAA1', 'AAA2', 'AAA3', 'AAA4');

INSERT INTO HR.TB_TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('CCC1', 'CCC2', 'CCC3', 'CCC4');

INSERT INTO HR.TB_TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('BBB1', 'BBB2', 'BBB3', 'BBB4');

INSERT INTO HR.TB_TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('EEE1', 'EEE2', 'EEE3', 'EEE4');

COMMIT;

-- Ȯ
SELECT *
FROM HR.TB_TEST_01;

--ε  NOSORT ɼ (ε ÿ )
--ε   Ȯ
CREATE INDEX HR.IDX_TB_TEST_01 ON HR.TB_TEST_01 (KEY_01) NOSORT;

--ĵ ͷ Է
TRUNCATE TABLE HR.TB_TEST_01;

INSERT INTO HR.TB_TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('AAA1', 'AAA2', 'AAA3', 'AAA4');

INSERT INTO HR.TB_TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('BBB1', 'BBB2', 'BBB3', 'BBB4');

INSERT INTO HR.TB_TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('CCC1', 'CCC2', 'CCC3', 'CCC4');

INSERT INTO HR.TB_TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('EEE1', 'EEE2', 'EEE3', 'EEE4');

COMMIT;

--NOSORT ɼ ε 
CREATE INDEX HR.IDX_TB_TEST_01 ON HR.TB_TEST_01 (KEY_01) NOSORT;

--ε Ŀ  ƴϴ Է°
INSERT INTO HR.TB_TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('DDD1', 'DDD2', 'DDD3', 'DDD4');

COMMIT;

-- Ȯ
SELECT *
FROM HR.TB_TEST_01;

/*
() SORT Ͼ ۾
1. ORDER BY
2. GROUP BY, HAVING
3. INDEX
4. UNION, MINUS, INTERSECT (SET OPERATED)
5. SORT MERGE JOIN
*/
  
--ε  Ȯ( Į )
SELECT *
FROM HR.TB_TEST_01
WHERE KEY_01 IN ('AAA1', 'BBB1', 'CCC1','EEE1', 'DDD1');

SELECT /*+INDEX (TB_TEST_01 IDX_TB_TEST_01) */ *
FROM HR.TB_TEST_01
WHERE KEY_01 IN ('AAA1', 'BBB1', 'CCC1','EEE1', 'DDD1');

--ε 
DROP INDEX HR.IDX_TB_TEST_01;

-- ε
-- Ȯ
SELECT *
FROM HR.TB_TEST_01;

-- ε
CREATE INDEX HR.IDX_TB_TEST_01 ON HR.TB_TEST_01 (KEY_01 DESC);

--ε  Ȯ( Į )
SELECT *
FROM HR.TB_TEST_01
WHERE KEY_01 IN ('AAA1', 'BBB1', 'CCC1','EEE1', 'DDD1');

-- ε (HINT )
SELECT /*+ INDEX (TB_TEST_01 IDX_TB_TEST_01)*/ *
FROM HR.TB_TEST_01
WHERE KEY_01 IN ('AAA1', 'BBB1', 'CCC1','EEE1', 'DDD1');

--ε 
DROP INDEX HR.IDX_TB_TEST_01;

-- ε ü Ŀ򿡸 ̰ ؼ ̸  
-- ε
--  ε ÿ  
CREATE INDEX HR.IDX_TB_TEST_01 ON HR.TB_TEST_01 (KEY_01 DESC) REVERSE;

-- ε
CREATE INDEX HR.IDX_TB_TEST_01 ON HR.TB_TEST_01 (KEY_01) REVERSE;


--INDEX ÿ  
SELECT /*+ index (TB_TEST_01 IDX_TB_TEST_01) */ *
FROM HR.TB_TEST_01
WHERE KEY_01 = ANY ('AAA1', 'CCC1', 'BBB1', 'EEE1', 'DDD1');

--ε 
DROP INDEX HR.IDX_TB_TEST_01;

--̺ 
DROP TABLE HR.TB_TEST_01 PURGE;

--Ϲ ε BITMAP ε 
--̺   ڷ 
CREATE TABLE HR.TB_TEST_01 (
    KEY_01,
    KEY_02,
    COL_01,
    COL_02
)
AS
SELECT MOD(LEVEL, 500000), MOD(LEVEL, 4000), MOD(LEVEL, 3000), MOD(LEVEL, 500) 
FROM DUAL
CONNECT BY LEVEL < 3000000;

--޸ Ȯ(ý )
ALTER SYSTEM SET PGA_AGGREGATE_TARGET = 2G SCOPE = BOTH;

--Ϲε 
CREATE INDEX HR.IDX_TB_TEST_01 ON HR.TB_TEST_01 (KEY_01);

--ε Ȯ (Cost : 23, Byte : 306, Cardinality : 18)
SELECT *
FROM HR.TB_TEST_01
WHERE KEY_01 = '2134' OR KEY_01 = '32134' OR KEY_01 = '432134'; 

--Ƽ ˼ ֵ ̺ м
ANALYZE TABLE HR.TB_TEST_01 COMPUTE STATISTICS; 

--м ε Ȯ (Cost : 23, Byte : 234, Cardinality : 18)
SELECT *
FROM HR.TB_TEST_01
WHERE KEY_01 = '2134' OR KEY_01 = '32134' OR KEY_01 = '432134'; 

--̺ (̺ мڷᵵ  Ű )
DROP TABLE HR.TB_TEST_01 PURGE;

--̺   ڷ 
CREATE TABLE HR.TB_TEST_01 (
    KEY_01,
    KEY_02,
    COL_01,
    COL_02
)
AS
SELECT MOD(LEVEL, 500000), MOD(LEVEL, 4000), MOD(LEVEL, 3000), MOD(LEVEL, 500) 
FROM DUAL
CONNECT BY LEVEL < 3000000;

--Ʈ ε
--Ʈ ε 
CREATE BITMAP INDEX HR.IDX_TB_TEST_BITMAP_01 ON HR.TB_TEST_01 (KEY_01);

--Ʈ ε Ȯ - ε  ȵ
SELECT *
FROM HR.TB_TEST_01
WHERE KEY_01 = '2134' OR KEY_01 = '32134' OR KEY_01 = '432134'; 

--Ƽ ˼ ֵ ̺ м
ANALYZE TABLE HR.TB_TEST_01 COMPUTE STATISTICS; 

--м ε Ȯ (Cost : 13, Byte : 234, Cardinality : 18)
SELECT *
FROM HR.TB_TEST_01
WHERE KEY_01 = '2134' OR KEY_01 = '32134' OR KEY_01 = '432134'; 

--̺ 
DROP TABLE HR.TB_TEST_01 PURGE;

--Ϲ ε Լ ε 
--   ڷ 
CREATE TABLE HR.TB_TEST_01 (
    KEY_01,
    KEY_02,
    COL_01,
    COL_02
)
AS
SELECT LEVEL, MOD(LEVEL, 4000), SYSDATE - MOD(LEVEL, 3000), CAST(MOD(LEVEL, 500) AS CHAR(3)) 
FROM DUAL
CONNECT BY LEVEL < 3000000;

--Ϲ ε 
-- Ÿ
CREATE INDEX HR.IDX_TB_TEST_01 ON HR.TB_TEST_01 (KEY_01);

-- Ÿ
CREATE INDEX HR.IDX_TB_TEST_02 ON HR.TB_TEST_01 (COL_01);

-- Ÿ
CREATE INDEX HR.IDX_TB_TEST_03 ON HR.TB_TEST_01 (COL_02);

--̺ м
ANALYZE TABLE HR.TB_TEST_01 COMPUTE STATISTICS;

--ȵ   Ȯ
SELECT *
FROM HR.TB_TEST_01
WHERE KEY_01 IN (30000, 45467);

--Լ ̿Ҷ ε   Ȯ
SELECT *
FROM HR.TB_TEST_01
WHERE MOD(KEY_01, 500000) IN (30000, 45467);

-- 1 (   Ȯ)
SELECT *
FROM HR.TB_TEST_01
WHERE KEY_01 / 10 = 300;

SELECT *
FROM HR.TB_TEST_01
WHERE KEY_01 = 300 * 10;

-- 2 (ڿ ) -  ȯ
SELECT *
FROM HR.TB_TEST_01
WHERE KEY_01 >= '2015';

SELECT *
FROM HR.TB_TEST_01
WHERE KEY_01 <= '2015';

-- 3 (ڷ ) -  ȯ
SELECT *
FROM HR.TB_TEST_01
WHERE COL_01 >= '2015-03-03';

--Լ  ε 
--̺ 
DROP TABLE HR.TB_TEST_01 PURGE;

--   ڷ 
CREATE TABLE HR.TB_TEST_01 (
    KEY_01,
    KEY_02,
    COL_01,
    COL_02
)
AS
SELECT LEVEL, MOD(LEVEL, 4000), SYSDATE - MOD(LEVEL, 3000), CAST(MOD(LEVEL, 500) AS CHAR(3)) 
FROM DUAL
CONNECT BY LEVEL < 3000000;

--Լ  ε 
CREATE INDEX HR.IDX_TB_TEST_01 ON HR.TB_TEST_01 (MOD(KEY_01, 500000), MOD(KEY_01, 3000));

--ε   Ȯ
SELECT *
FROM HR.TB_TEST_01
WHERE MOD(KEY_01, 500000) IN (30000, 45467);

--̺ 
DROP TABLE HR.TB_TEST_01 PURGE;

--Ϲ̺ ε̺ 
-- Ϲ̺ 
CREATE TABLE HR.TB_TEST_01 (
    KEY_01  VARCHAR2(10),
    COL_01  VARCHAR2(100),
    CONSTRAINTS PK_TB_TEST_01 PRIMARY KEY (KEY_01)
);

--ڷԷ
INSERT INTO HR.TB_TEST_01 (KEY_01, COL_01)
VALUES ('AAAA', 'AAAA');
         
INSERT INTO HR.TB_TEST_01 (KEY_01, COL_01)
VALUES ('DDDD', 'DDDD');
         
INSERT INTO HR.TB_TEST_01 (KEY_01, COL_01)
VALUES ('CCCC', 'CCCC');         
         
INSERT INTO HR.TB_TEST_01 (KEY_01, COL_01)
VALUES ('BBBB', 'BBBB');
         
COMMIT;
         
--ڷȸ-Ϲڷ
SELECT *
FROM HR.TB_TEST_01;

DROP TABLE HR.TB_TEST_01 PURGE;

--ε  ̺ ()
--Ű  ε  ̺  
CREATE TABLE HR.TB_TEST_01 (
    KEY_01  VARCHAR2(10),
    COL_01  VARCHAR2(100)
)
ORGANIZATION INDEX;

--ε  ̺ 
CREATE TABLE HR.TB_TEST_01 (
    KEY_01  VARCHAR2(10),
    COL_01  VARCHAR2(100),
    CONSTRAINTS PK_TB_TEST_01 PRIMARY KEY (KEY_01)
)
ORGANIZATION INDEX;

--ڷԷ
INSERT INTO HR.TB_TEST_01 (KEY_01, COL_01)
VALUES ('AAAA', 'AAAA');
         
INSERT INTO HR.TB_TEST_01 (KEY_01, COL_01)
VALUES ('DDDD', 'DDDD');
         
INSERT INTO HR.TB_TEST_01 (KEY_01, COL_01)
VALUES ('CCCC', 'CCCC');         
         
INSERT INTO HR.TB_TEST_01 (KEY_01, COL_01)
VALUES ('BBBB', 'BBBB');
         
COMMIT;
         
--ڷȸ
SELECT *
FROM HR.TB_TEST_01;

--̺ 
DROP TABLE HR.TB_TEST_01 PURGE;


--̺ 
CREATE TABLE HR.TB_TEST_01 (
    KEY_01  VARCHAR2(10),
    KEY_02  VARCHAR2(10),
    COL_01  VARCHAR2(100),
    COL_02  VARCHAR2(100)
);

-- Է
INSERT INTO HR.TB_TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('AAA1', 'AAA2', 'AAA3', 'AAA4');

INSERT INTO HR.TB_TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('CCC1', 'CCC2', 'CCC3', 'CCC4');

INSERT INTO HR.TB_TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('BBB1', 'BBB2', 'BBB3', 'BBB4');

INSERT INTO HR.TB_TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('EEE1', 'EEE2', 'EEE3', 'EEE4');

COMMIT;

--ε 
CREATE INDEX HR.IDX_TB_TEST_01 ON HR.TB_TEST_01 (KEY_01);

--ε м(Ǿȿ )
ANALYZE INDEX HR.IDX_TB_TEST_01 VALIDATE STRUCTURE;

--м Ȯ
SELECT *
FROM INDEX_STATS;

--ε ߷ Ȯ
SELECT (DEL_LF_ROWS_LEN/ LF_ROWS_LEN) * 100 AS IDX_BAL 
FROM INDEX_STATS; 

--߷ ر   
DELETE
FROM HR.TB_TEST_01
WHERE KEY_01 = ANY('AAA1', 'BBB1');

COMMIT;

--̺ м
ANALYZE INDEX HR.IDX_TB_TEST_01 VALIDATE STRUCTURE;

--߷ Ȯ(50% ر) ->  20% ̸̻ 籸ʿ 
SELECT (DEL_LF_ROWS_LEN/ LF_ROWS_LEN) * 100 AS IDX_BAL 
FROM INDEX_STATS; 

--ε 籸
--LEAF LEVEL 籸
ALTER INDEX HR.IDX_TB_TEST_01 COALESCE;

--м
ANALYZE INDEX HR.IDX_TB_TEST_01 VALIDATE STRUCTURE;

--߷ Ȯ 
SELECT (DEL_LF_ROWS_LEN/ LF_ROWS_LEN) * 100 AS IDX_BAL 
FROM INDEX_STATS; 

--ü 籸
ALTER INDEX HR.IDX_TB_TEST_01 REBUILD;

--ü 籸(̺  ϰ óϴ )
ALTER INDEX HR.IDX_TB_TEST_01 REBUILD ONLINE;


--ε ͸(ε Ǿ ƴ Ȯ ϴ )
ALTER INDEX HR.IDX_TB_TEST_01 MONITORING USAGE;

--Ȯ
SELECT *
FROM V$OBJECT_USAGE;

--ε ͸ 
ALTER INDEX HR.IDX_TB_TEST_01 NOMONITORING USAGE;

--Ȯ
SELECT *
FROM V$OBJECT_USAGE;

--    ͸ ϸ ٽ   ĺ ε  Ȯ
--  ε ϸ  
 
--ε ̸ 
ALTER INDEX HR.IDX_TB_TEST_01 RENAME TO IDX_TB_TEST_02;

--ε  Ȯ
SELECT *
FROM ALL_INDEXES 
WHERE INDEX_NAME = ANY('IDX_TB_TEST_01', 'IDX_TB_TEST_02');

--ε   
--
--οͽƮ ߰
--
--̻ ͽƮ 
--

-- (ε )
-- ̺ (GEOM -> ǥ ʵ)
CREATE TABLE HR.TB_SPATIAL (
    KEY_01 NUMBER PRIMARY KEY,
    COL_01 VARCHAR2(30),
    GEOM   MDSYS.SDO_GEOMETRY
);

--ݵ   ( HR)
--ǥ Է( , 8307 WGS 84 ǥ)
INSERT INTO USER_SDO_GEOM_METADATA VALUES(
'TB_SPATIAL','TEST', MDSYS.SDO_DIM_ARRAY(MDSYS.SDO_DIM_ELEMENT('X',-180,180, 0.5),
                                         MDSYS.SDO_DIM_ELEMENT('Y',-90,90, 0.5)), 8307);

COMMIT;

--Է Ȯ
SELECT *
FROM USER_SDO_GEOM_METADATA;

--ε 
CREATE INDEX IDX_TB_SPATIAL ON TB_SPATIAL(GEOM)
INDEXTYPE IS MDSYS.SPATIAL_INDEX;

--ε Ȯ
SELECT *
FROM ALL_INDEXES
WHERE TABLE_NAME = 'TB_SPATIAL';