DROP TABLE HR.TB_TEST_01 PURGE;

--׽Ʈ  ̺ 
CREATE TABLE HR.TB_TEST_01 (
    KEY_01  VARCHAR2(10),
    COL_01  VARCHAR2(100),
    COL_02  VARCHAR2(100),
    CONSTRAINT PK_KEY_01 PRIMARY KEY (KEY_01)
);

--ε 
CREATE INDEX HR.IDX_01_TEST_01 ON HR.TB_TEST_01 (COL_01);

-- Է
INSERT INTO HR.TB_TEST_01(KEY_01, COL_01, COL_02)
VALUES ('AAA', 'AAA', 'AAA');

INSERT INTO HR.TB_TEST_01(KEY_01, COL_01, COL_02)
VALUES ('BBB', 'BBB', 'BBB');

INSERT INTO HR.TB_TEST_01(KEY_01, COL_01, COL_02)
VALUES ('CCC', 'CCC', 'CCC');

INSERT INTO HR.TB_TEST_01(KEY_01, COL_01, COL_02)
VALUES ('DDD', 'DDD', 'DDD');

COMMIT;

-- ð SCN ȣ Ȯ(DBA   ؾ )
SELECT CURRENT_SCN, SYSTIMESTAMP
FROM v$DATABASE;

--30004804    2015/05/10  1:36:13.642000 +09:00

SELECT TO_TIMESTAMP('2015-05-10 01:36:13', 'YYYY-MM-DD HH24:MI:SS')
FROM DUAL;

-- 
DELETE FROM HR.TB_TEST_01;

COMMIT;

-- Ȯ
SELECT *
FROM HR.TB_TEST_01;

--÷ ̿ Ȯ
--Ÿӽ ̿
EXEC DBMS_FLASHBACK.ENABLE_AT_TIME (TO_TIMESTAMP('2015-05-10 01:36:13', 'YYYY-MM-DD HH24:MI:SS'));

EXEC DBMS_FLASHBACK.DISABLE;

EXEC DBMS_FLASHBACK.ENABLE_AT_SYSTEM_CHANGE_NUMBER (30004804);

--÷  Ķ (SQLPLUS)
SHOW PARAMETER UNDO;
--undo_management    AUTO
--undo_retention    900    
--undo_tablespace    UNDOTBS1    


--÷ ̿  
SELECT *
FROM HR.TB_TEST_01;

--Ưð 
--
SELECT *
FROM HR.TB_TEST_01
AS OF TIMESTAMP(SYSDATE - INTERVAL '10' MINUTE);

--ð
SELECT *
FROM HR.TB_TEST_01
AS OF TIMESTAMP(TO_TIMESTAMP('2015-05-10 01:36:13', 'YYYY-MM-DD HH24:MI:SS'));

--SCN
SELECT *
FROM HR.TB_TEST_01
AS OF SCN(30004804);

INSERT INTO HR.TB_TEST_01
SELECT *
FROM HR.TB_TEST_01
AS OF SCN(30004804);

COMMIT;

SELECT *
FROM HR.TB_TEST_01;

--÷ Ű ̿ 
DECLARE
    --Ŀ 
    CURSOR TEST_CUR
    IS
    SELECT *
    FROM HR.TB_TEST_01;
    
    --Ŀ   
    V_RECORD HR.TB_TEST_01%ROWTYPE;
BEGIN
    
    --
    DBMS_FLASHBACK.ENABLE_AT_TIME (TO_TIMESTAMP(:BACKUP_TIME, 'YYYY-MM-DD HH24:MI:SS'));
    
    OPEN TEST_CUR;
    
    DBMS_FLASHBACK.DISABLE;
    
    LOOP
        FETCH TEST_CUR INTO V_RECORD;
        
        EXIT WHEN TEST_CUR%NOTFOUND;
        
        INSERT INTO HR.TB_TEST_01 (KEY_01, COL_01, COL_02)
        VALUES (V_RECORD.KEY_01, V_RECORD.COL_01, V_RECORD.COL_02);
        
    END LOOP;
    
    CLOSE TEST_CUR;
    
    COMMIT;
END;
/

--̺  
DROP TABLE HR.TB_TEST_01;

-- Ȯ
SELECT *
FROM HR.TB_TEST_01;

-- Ȯ
SELECT *
FROM DBA_RECYCLEBIN
WHERE OWNER = 'HR';

--Recycle bin ش  ־ 
FLASHBACK TABLE HR.TB_TEST_01 TO BEFORE DROP;

-- ̿ Ʈ ̸ Ͽ  ߻
SELECT *
FROM ALL_INDEXES
WHERE OWNER = 'HR'
AND TABLE_NAME = 'TB_TEST_01';

SELECT *
FROM ALL_CONSTRAINTS
WHERE OWNER = 'HR'
AND TABLE_NAME = 'TB_TEST_01';

ALTER TABLE HR.TB_TEST_01
 RENAME CONSTRAINT "BIN$D/4EcM2zTb6pnw4Ogf1QkQ==$0" TO PK_TEST_01;

SELECT *
FROM ALL_INDEXES
WHERE OWNER = 'HR'
AND TABLE_NAME = 'TB_TEST_01';

ALTER INDEX "BIN$ogOw+I6jTneM+R064cvfdA==$0" RENAME TO PK_TEST_01;

ALTER INDEX "BIN$ozKtdi/VTD2e08Ovetcp9A==$0" RENAME TO IDX_01_TEST_01;

SELECT *
FROM ALL_TRIGGERS
WHERE OWNER = 'HR'
AND TABLE_NAME = 'TB_TEST_01';

ALTER TRIGGER "BIN$FKwjaOmHMLTgUwq2EpQwtA==$2" RENAME TO TR_TEST_01_ALL;

--exp ̿  (Ŭ̾Ʈ ̿)
exp hr/hr@orcl file = 'c:\test\tb_test_01_bk.dmp' tables=tb_test_01;

--̺ ٲٱ
--̺ 
DROP TABLE HR.TB_TEST_01;

--ο ̺ ̸ Ͽ 
FLASHBACK TABLE HR.TB_TEST_01 TO BEFORE DROP RENAME TO TB_TEST_01_BK;

SELECT *
FROM HR.TB_TEST_01_BK;

--̺  PURGE ɼ   ȵ
DROP TABLE HR.TB_TEST_01_BK PURGE;

-- 
FLASHBACK TABLE HR.TB_TEST_01_BK TO BEFORE DROP;

--imp ̺ 
SELECT *
FROM HR.TB_TEST_01;

SELECT *
FROM ALL_INDEXES
WHERE OWNER = 'HR'
AND TABLE_NAME = 'TB_TEST_01';

--̺ 
DROP TABLE HR.TB_TEST_01 PURGE;

--imp hr/hr@orcl file = 'c:\test\tb_test_01.dmp' fromuser=ctest touser=ctest tables=tb_test_01
imp hr/hr@orcl file = 'c:\test\tb_test_01_bk.dmp' tables=tb_test_01;

--
SELECT *
FROM HR.TB_TEST_01;

SELECT *
FROM ALL_INDEXES
WHERE OWNER = 'HR'
AND TABLE_NAME = 'TB_TEST_01';

SELECT *
FROM ALL_CONSTRAINTS
WHERE OWNER = 'HR'
AND TABLE_NAME = 'TB_TEST_01';

-- ð SCN ȣ Ȯ
SELECT CURRENT_SCN, SYSTIMESTAMP
FROM v$DATABASE;

--30117681    2015/05/11  1:06:47.378000 +09:00

--  ̺   
--Ÿ 
DELETE FROM HR.TB_TEST_01;

COMMIT;

--SCN Ȯ
SELECT *
FROM HR.TB_TEST_01
AS OF SCN(30117681);

--̺ 
DROP TABLE HR.TB_TEST_01;

-- ̺ 
FLASHBACK TABLE HR.TB_TEST_01 TO BEFORE DROP;

--  
INSERT INTO HR.TB_TEST_01
SELECT *
FROM HR.TB_TEST_01
AS OF SCN(30117681);

COMMIT;

--  ̺  ̺ 
-- ð SCN ȣ Ȯ
SELECT CURRENT_SCN, SYSTIMESTAMP
FROM v$DATABASE

30117790    2015/05/11  1:09:05.509000 +09:00

-- Ȯ
SELECT *
FROM HR.TB_TEST_01;

--Ÿ 
DELETE FROM HR.TB_TEST_01;

COMMIT;

--̺  
DROP TABLE HR.TB_TEST_01;

--׽Ʈ  ̺ 
CREATE TABLE HR.TB_TEST_01 (
    KEY_01  VARCHAR2(10),
    COL_01  VARCHAR2(100),
    COL_02  VARCHAR2(100),
    CONSTRAINT PK_KEY_01 PRIMARY KEY (KEY_01)
);

--÷  ( ȵ)
SELECT *
FROM HR.TB_TEST_01
AS OF SCN(30117790);

--import ̿
-- ̺  
imp hr/hr@orcl file = 'c:\test\tb_test_01_bk.dmp' tables=tb_test_01 

-- ̺   ȳ ڷ Է
imp hr/hr@orcl file = 'c:\test\tb_test_01_bk.dmp' tables=tb_test_01 IGNORE=Y

--import Ȯ
SELECT *
FROM HR.TB_TEST_01;

SELECT *
FROM ALL_INDEXES
WHERE OWNER = 'HR'
AND TABLE_NAME = 'TB_TEST_01';

SELECT *
FROM ALL_CONSTRAINTS
WHERE OWNER = 'HR'
AND TABLE_NAME = 'TB_TEST_01';


--expdp  丮  
--丮 
CREATE OR REPLACE DIRECTORY TEST_PUMP AS 'c:\test';

GRANT EXECUTE, READ, WRITE ON DIRECTORY TEST_PUMP TO HR;

--expdp ̿
expdp hr/hr@orcl directory = TEST_PUMP dumpfile = 'tb_test_pump.dmp' tables=TB_TEST_01 logfile = 'tb_test_pump.log' 

--impdp̿
impdp hr/hr@orcl directory = TEST_PUMP dumpfile = 'tb_test_pump.dmp' tables=TB_TEST_01 


