--NULL NOT NULL 
--̺ ÿ  ϴ 
DROP TABLE TB_TEST;

CREATE TABLE TB_TEST (
    COL_01 VARCHAR2(10) NOT NULL,
    COL_02 VARCHAR2(20) 
);

-- 
INSERT INTO TB_TEST (COL_01, COL_02)
VALUES ('AAA', 'AAA');

INSERT INTO TB_TEST (COL_01, COL_02)
VALUES ('BBB', '');

INSERT INTO TB_TEST (COL_01, COL_02)
VALUES ('', 'CCC');

COMMIT;

--̺   ( ÷ ) -  Ѿ 
ALTER TABLE TB_TEST
MODIFY COL_02 VARCHAR2(20) NOT NULL;

--̺   -  Ѿ 
ALTER TABLE TB_TEST
ADD COL_03 VARCHAR2(20) NOT NULL;

--̺   -  Ѿ ->  ȵ
ALTER TABLE TB_TEST
MODIFY COL_01 VARCHAR2(10);

--̺   -  Ѿ 
ALTER TABLE TB_TEST
MODIFY COL_01 VARCHAR2(10) NULL;

--⺻ ÷ ߰
ALTER TABLE TB_TEST
MODIFY COL_02 VARCHAR2(20) DEFAULT 'LOW';

ALTER TABLE TB_TEST
ADD COL_03 VARCHAR2(20) DEFAULT 'TOP';


-- Ȯ
SELECT *
FROM TB_TEST;

UPDATE TB_TEST SET COL_03 = NULL;

INSERT INTO TB_TEST (COL_01, COL_02, COL_03)
VALUES ('CCC', '', NULL);

INSERT INTO TB_TEST (COL_01, COL_02, COL_03)
VALUES ('DDD', 'DDD', '');

INSERT INTO TB_TEST (COL_01, COL_02)
VALUES ('EEE', 'EEE');

SELECT *
FROM TB_TEST;

COMMIT;

--̺  - ⺻Ű 
DROP TABLE TEST_01;
--Į   - ߸  
CREATE TABLE TEST_01 (
  KEY_01 VARCHAR2(10) CONSTRAINT PK_TEST_01 PRIMARY KEY,
  KEY_02 VARCHAR2(10) CONSTRAINT PK_TEST_01 PRIMARY KEY,
  COL_01 VARCHAR2(100),
  COL_02 VARCHAR2(100)
);

--Į   - 
CREATE TABLE TEST_01 (
  KEY_01 VARCHAR2(10) CONSTRAINT PK_TEST_01 PRIMARY KEY USING INDEX TABLESPACE USERS,
  KEY_02 VARCHAR2(10),
  COL_01 VARCHAR2(100),
  COL_02 VARCHAR2(100)
);

--̺  
DROP TABLE TEST_01;

CREATE TABLE TEST_01 (
  KEY_01 VARCHAR2(10),
  KEY_02 VARCHAR2(10),
  COL_01 VARCHAR2(100),
  COL_02 VARCHAR2(100),
  CONSTRAINT PK_TEST_01 PRIMARY KEY (KEY_01, KEY_02) USING INDEX TABLESPACE USERS
);

-- ̺ ⺻Ű 
--̺ 
DROP TABLE TEST_01;

--̺
CREATE TABLE TEST_01 (
  KEY_01 VARCHAR2(10),
  KEY_02 VARCHAR2(10),
  COL_01 VARCHAR2(100),
  COL_02 VARCHAR2(100)
);

-- ⺻Ű -̺
ALTER TABLE TEST_01
ADD CONSTRAINT PK_TEST_01 PRIMARY KEY (KEY_01, KEY_02) USING INDEX TABLESPACE USERS;

--⺻Ű
ALTER TABLE TEST_01
DROP CONSTRAINT PK_TEST_01;

--⺻Ű -Į
ALTER TABLE TEST_01
MODIFY KEY_01 VARCHAR2(10) CONSTRAINT PK_TEST_01 PRIMARY KEY USING INDEX TABLESPACE USERS;

--Ǵٸ ⺻Ű  
ALTER TABLE TEST_01
DROP PRIMARY KEY;

INSERT INTO TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('AAA', '001', 'A', 'B');

INSERT INTO TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('AAA', '002', 'A', 'B');

INSERT INTO TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('AAA', '', 'A', 'B');

INSERT INTO TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('BBB', '001', 'A', 'B');

INSERT INTO TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('BBB', '002', 'A', 'B');

INSERT INTO TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('BBB', '', 'A', 'B');

DELETE 
FROM TEST_01
WHERE KEY_02 IS NULL;

SELECT *
FROM TEST_01;

COMMIT;

--⺻Ű ۵ 
ALTER TABLE TEST_01
DISABLE CONSTRAINT PK_TEST_01;

ROLLBACK;

--⺻Ű ۵
ALTER TABLE TEST_01
ENABLE CONSTRAINT PK_TEST_01;


--⺻Ű ۵ 
ALTER TABLE TEST_01
DISABLE PRIMARY KEY;

--⺻Ű ۵
ALTER TABLE TEST_01
ENABLE PRIMARY KEY;

--̺  - Ű 
--Į   - ߸ 
DROP TABLE TEST_01;
 
CREATE TABLE TEST_01 (
  KEY_01 VARCHAR2(10) CONSTRAINT UK_TEST_01 UNIQUE,
  KEY_02 VARCHAR2(10) CONSTRAINT UK_TEST_01 UNIQUE,
  COL_01 VARCHAR2(100),
  COL_02 VARCHAR2(100)
);

--Į   - 
CREATE TABLE TEST_01 (
  KEY_01 VARCHAR2(10) CONSTRAINT UK_TEST_01 UNIQUE USING INDEX TABLESPACE USERS,
  KEY_02 VARCHAR2(10),
  COL_01 VARCHAR2(100),
  COL_02 VARCHAR2(100)
);

--̺  
DROP TABLE TEST_01;

CREATE TABLE TEST_01 (
  KEY_01 VARCHAR2(10),
  KEY_02 VARCHAR2(10),
  COL_01 VARCHAR2(100),
  COL_02 VARCHAR2(100),
  CONSTRAINT UK_TEST_01 UNIQUE (KEY_01, KEY_02) USING INDEX TABLESPACE USERS
);

-- ̺ Ű 
--̺ 
DROP TABLE TEST_01;

--̺
CREATE TABLE TEST_01 (
  KEY_01 VARCHAR2(10),
  KEY_02 VARCHAR2(10),
  COL_01 VARCHAR2(100),
  COL_02 VARCHAR2(100)
);

-- Ű -̺
ALTER TABLE TEST_01
ADD ( CONSTRAINT UK_TEST_01 UNIQUE (KEY_01, KEY_02) USING INDEX TABLESPACE USERS,
      CONSTRAINT UK_TEST_02 UNIQUE (KEY_01) USING INDEX TABLESPACE USERS );

-- Ű 
ALTER TABLE TEST_01
DROP CONSTRAINT UK_TEST_01
DROP CONSTRAINT UK_TEST_02;

--Ű -Į
ALTER TABLE TEST_01
MODIFY KEY_01 VARCHAR2(10) CONSTRAINT UK_TEST_01 UNIQUE USING INDEX TABLESPACE USERS;

--Ǵٸ Ű  
ALTER TABLE TEST_01
DROP UNIQUE (KEY_01);

INSERT INTO TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('AAA', '001', 'A', 'B');

INSERT INTO TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('AAA', '002', 'A', 'B');

INSERT INTO TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('AAA', '', 'A', 'B');

INSERT INTO TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('BBB', '001', 'A', 'B');

INSERT INTO TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('BBB', '002', 'A', 'B');

INSERT INTO TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('BBB', '', 'A', 'B');

ALTER TABLE TEST_01
ADD CONSTRAINT UK_TEST_01 UNIQUE (KEY_01, KEY_02) USING INDEX TABLESPACE USERS;

INSERT INTO TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('', 'A', 'C', 'C');

INSERT INTO TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('', 'A', 'D', 'D');

COMMIT;

--Ű ۵ 
ALTER TABLE TEST_01
DISABLE CONSTRAINT UK_TEST_01;

INSERT INTO TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('AAA', '001', 'C', 'C');

ROLLBACK;

DELETE
FROM TEST_01
WHERE (COL_01 || COL_02) = ANY ('CC', 'DD')
AND KEY_01 IS NOT NULL;

COMMIT; 

--Ű ۵
ALTER TABLE TEST_01
ENABLE CONSTRAINT UK_TEST_01;

--Ű ۵ 
ALTER TABLE TEST_01
DISABLE UNIQUE(KEY_01, KEY_02);

--Ű ۵
ALTER TABLE TEST_01
ENABLE UNIQUE(KEY_01, KEY_02);

--üũ
--̺ -üũ 
DROP TABLE TEST_01;

CREATE TABLE TEST_01 (
  KEY_01 VARCHAR2(10),
  KEY_02 VARCHAR2(10),
  COL_01 VARCHAR2(100),
  COL_02 NUMBER,
  CONSTRAINT CHK_TEST_01 CHECK (COL_01 IN ('', '', 'Ÿ')),
  CONSTRAINT CHK_TEST_02 CHECK (COL_02 >= 1 AND COL_02 <= 999)
);

INSERT INTO TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('AAA', '001', '', 0);

INSERT INTO TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('AAA', '001', '', 3);

INSERT INTO TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('AAA', '001', 'TEST', 3);

SELECT *
FROM TEST_01;  

--̺ üũ 
DROP TABLE TEST_01;

CREATE TABLE TEST_01 (
  KEY_01 VARCHAR2(10),
  KEY_02 VARCHAR2(10),
  COL_01 VARCHAR2(100),
  COL_02 NUMBER
);

ALTER TABLE TEST_01
ADD (CONSTRAINT CHK_TEST_01_1 CHECK (COL_01 IN ('', '', 'Ÿ')), 
     CONSTRAINT CHK_TEST_01_2 CHECK (COL_02 >= 1 AND COL_02 <= 999),
     CONSTRAINT CHK_TEST_01_3 CHECK (COL_01 IN ('', '', 'Ÿ')));

--üũ     
ALTER TABLE TEST_01
MODIFY COL_01 VARCHAR(100) CONSTRAINT CHK_TEST_01_4 CHECK ((COL_01 = '' AND COL_02 = 1) OR (COL_01 = '' AND COL_02 = 2)); 

ALTER TABLE TEST_01
MODIFY COL_01 VARCHAR(100) CONSTRAINT CHK_TEST_01_4 CHECK (COL_01 = TO_CHAR(SYSDATE, 'YYYYMMDD')); 

ALTER TABLE TEST_01
MODIFY COL_01 VARCHAR(100) CONSTRAINT CHK_TEST_01_4 CHECK (COL_01 = TO_CHAR(TO_DATE('20140101', 'YYYYMMDD'), 'YYYYMMDD')); 

INSERT INTO TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('AAA', '001', '', 2);

--  
DROP TABLE TEST_01;

CREATE TABLE TEST_01 (
  KEY_01 VARCHAR2(10),
  KEY_02 VARCHAR2(10),
  COL_01 VARCHAR2(100),
  COL_02 NUMBER
);

ALTER TABLE TEST_01
ADD CONSTRAINT CHK_TEST_01_1
    CHECK ((COL_01 = '' AND COL_02 = 1) 
        OR (COL_01 = '' AND COL_02 = 2));

INSERT INTO TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('AAA', '001', '', 2);

INSERT INTO TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('AAA', '002', '', 2);

INSERT INTO TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('AAA', '002', '', 2);

INSERT INTO TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('AAA', '003', '', NULL);

INSERT INTO TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('AAA', '004', '', NULL);

INSERT INTO TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('AAA', '005', '', '');

INSERT INTO TEST_01 (KEY_01, KEY_02, COL_01, COL_02)
VALUES ('AAA', '006', '', '3');

--üũ
ALTER TABLE TEST_01
DROP CONSTRAINT CHK_TEST_01_1;

--üũ
ALTER TABLE TEST_01
ADD CONSTRAINT CHK_TEST_01_1
    CHECK ((COL_01 = '' AND COL_02 = 1) 
        OR (COL_01 = '' AND COL_02 = 2));

--üũ
ALTER TABLE TEST_01
DISABLE CONSTRAINT CHK_TEST_01_1;

--üũ 
ALTER TABLE TEST_01
ENABLE CONSTRAINT CHK_TEST_01_1;


--ܷŰ
--θ̺ 
DROP TABLE TEST_PAR;

CREATE TABLE TEST_PAR (
    KEY_01 VARCHAR2(10),
    KEY_02 VARCHAR2(10),
    COL_01 VARCHAR2(100),
    COL_02 VARCHAR2(100),
    UK_KEY_01 VARCHAR2(10),
    UK_KEY_02 VARCHAR2(10),
    CONSTRAINT PK_TEST_PAR PRIMARY KEY(KEY_01, KEY_02),
    CONSTRAINT UK1_TEST_PAR UNIQUE (UK_KEY_01, UK_KEY_02)
);

--̺  ܷŰ 
DROP TABLE TEST_CHD;

CREATE TABLE TEST_CHD (
    KEY_01     VARCHAR2(10) CONSTRAINT PK_TEST_CHD PRIMARY KEY,
    COL_01     VARCHAR2(100),
    COL_02     VARCHAR2(100),
    FK1_KEY_01 VARCHAR2(20),
    FK1_KEY_02 VARCHAR2(5),
    CONSTRAINT FK1_TEST_CHD FOREIGN KEY (FK1_KEY_01, FK1_KEY_02)
    REFERENCES TEST_PAR(KEY_01, KEY_02)
);

INSERT INTO TEST_PAR (KEY_01, KEY_02, COL_01, COL_02, UK_KEY_01, UK_KEY_02)
VALUES ('1234567890', '1234567890', 'A', 'B', 'AAA', '001');

--Ű  Ÿ  ٸ Ҷ  ߻
INSERT INTO TEST_CHD (KEY_01, COL_01, COL_02, FK1_KEY_01, FK1_KEY_02)
VALUES ('1234567890', 'AAA', 'BBB', '1234567890', '12345');

--ϰ ܷŰ 
DROP TABLE TEST_CHD;

CREATE TABLE TEST_CHD (
    KEY_01     VARCHAR2(10) CONSTRAINT PK_TEST_CHD PRIMARY KEY,
    COL_01     VARCHAR2(100),
    COL_02     VARCHAR2(100),
    FK1_KEY_01 VARCHAR2(10),
    FK1_KEY_02 VARCHAR2(10),
    CONSTRAINT FK1_TEST_CHD FOREIGN KEY (FK1_KEY_01, FK1_KEY_02)
    REFERENCES TEST_PAR(KEY_01, KEY_02)
);

-- Է
INSERT INTO TEST_CHD (KEY_01, COL_01, COL_02, FK1_KEY_01, FK1_KEY_02)
VALUES ('1234567890', 'AAA', 'BBB', '1234567890', '1234567890');

COMMIT;

--̺  ܷŰ 
ALTER TABLE TEST_CHD
ADD (FK2_KEY_01 VARCHAR2(10), FK2_KEY_02 VARCHAR2(10)) 
ADD CONSTRAINT FK2_TEST_CHD FOREIGN KEY (FK2_KEY_01, FK2_KEY_02)
    REFERENCES TEST_PAR(UK_KEY_01, UK_KEY_02);

-- Է    
INSERT INTO TEST_CHD (KEY_01, COL_01, COL_02, FK2_KEY_01, FK2_KEY_02)
VALUES ('1', 'CCC', 'DDD', '1234567890', '1234567890');

INSERT INTO TEST_CHD (KEY_01, COL_01, COL_02, FK2_KEY_01, FK2_KEY_02)
VALUES ('1', 'CCC', 'DDD', 'AAA', '001');

INSERT INTO TEST_CHD (KEY_01, COL_01, COL_02, FK2_KEY_01, FK2_KEY_02)
VALUES ('2', 'CCC', 'DDD', '', '001');

INSERT INTO TEST_CHD (KEY_01, COL_01, COL_02, FK1_KEY_01, FK1_KEY_02, FK2_KEY_01, FK2_KEY_02)
VALUES ('3', 'CCC', 'DDD', '', '', '', '');

-- ( Ű   NULL̸ Է )
INSERT INTO TEST_CHD (KEY_01, COL_01, COL_02, FK1_KEY_01, FK1_KEY_02, FK2_KEY_01, FK2_KEY_02)
VALUES ('4', 'CCC', 'DDD', '', '1', '', '1');

INSERT INTO TEST_CHD (KEY_01, COL_01, COL_02, FK1_KEY_01, FK1_KEY_02, FK2_KEY_01, FK2_KEY_02)
VALUES ('7', 'CCC', 'DDD', '1', '', '1', '');
    
SELECT *
FROM TEST_PAR;

SELECT *
FROM TEST_CHD;

COMMIT;