--BLOB
DROP TABLE TB_BLOB;

CREATE TABLE TB_BLOB (
    COL_BLOB1 BLOB
);

-- BLOB 
DECLARE
    V_BFILE     BFILE;
    V_BLOB      BLOB;
BEGIN
    INSERT INTO TB_BLOB (COL_BLOB1)
    VALUES (empty_blob())
    RETURN COL_BLOB1 INTO V_BLOB;
    
    V_BFILE := BFILENAME('TEST_DIR', 'img01.jpg');
    DBMS_LOB.FILEOPEN(V_BFILE, DBMS_LOB.FILE_READONLY);
    DBMS_LOB.LOADFROMFILE(V_BLOB, V_BFILE, DBMS_LOB.GETLENGTH(V_BFILE));
    DBMS_LOB.FILECLOSE(V_BFILE);

    COMMIT;
END;

SELECT COL_BLOB1
FROM TB_BLOB;

