SELECT A.FIRST_NAME, A.LAST_NAME, B.DEPARTMENT_NAME
  FROM EMPLOYEES A, DEPARTMENTS B
 WHERE A.DEPARTMENT_ID = B.DEPARTMENT_ID
   AND A.FIRST_NAME LIKE 'John%';

EXPLAIN PLAN FOR
SELECT A.FIRST_NAME, A.LAST_NAME, B.DEPARTMENT_NAME
  FROM EMPLOYEES A, DEPARTMENTS B
 WHERE A.DEPARTMENT_ID = B.DEPARTMENT_ID
   AND A.FIRST_NAME LIKE 'John%';
   
SELECT * 
  FROM TABLE(DBMS_XPLAN.DISPLAY);

