--񱳿
SELECT FIRST_NAME, LAST_NAME, SALARY
FROM EMPLOYEES
WHERE FIRST_NAME = 'Julia';

SELECT FIRST_NAME, LAST_NAME, SALARY
FROM EMPLOYEES
WHERE SALARY >= 9000;

SELECT FIRST_NAME, LAST_NAME, SALARY
FROM EMPLOYEES
WHERE FIRST_NAME >= 'Shanta';

SELECT FIRST_NAME, LAST_NAME, SALARY
FROM EMPLOYEES
WHERE FIRST_NAME >= 'a';

--mull  ó
SELECT FIRST_NAME, LAST_NAME, MANAGER_ID 
FROM EMPLOYEES
WHERE MANAGER_ID = '';

SELECT FIRST_NAME, LAST_NAME, MANAGER_ID 
FROM EMPLOYEES
WHERE MANAGER_ID IS NULL;

SELECT FIRST_NAME, LAST_NAME, MANAGER_ID
FROM EMPLOYEES
WHERE MANAGER_ID IS NOT NULL;

--
SELECT FIRST_NAME, LAST_NAME, SALARY
FROM EMPLOYEES
WHERE FIRST_NAME = 'Julia'
OR FIRST_NAME = 'John';

SELECT FIRST_NAME, LAST_NAME, SALARY
FROM EMPLOYEES
WHERE FIRST_NAME = 'Julia'
OR FIRST_NAME = 'John'
AND SALARY > 3000;

--all
SELECT FIRST_NAME, LAST_NAME, SALARY
FROM EMPLOYEES
WHERE FIRST_NAME = ALL('Julia', 'John');

SELECT FIRST_NAME, LAST_NAME, SALARY
FROM EMPLOYEES
WHERE FIRST_NAME = 'Julia'
AND   FIRST_NAME = 'John';

SELECT FIRST_NAME, LAST_NAME, SALARY
FROM EMPLOYEES
WHERE FIRST_NAME = ALL('Julia', 'John');

SELECT FIRST_NAME, LAST_NAME, SALARY
FROM EMPLOYEES
WHERE FIRST_NAME >= 'Julia'
AND   FIRST_NAME >= 'John';

SELECT FIRST_NAME, LAST_NAME, SALARY
FROM EMPLOYEES
WHERE SALARY = ALL (SELECT SALARY FROM EMPLOYEES
                      WHERE JOB_ID = 'IT_PROG');
                    
EXPLAIN PLAN FOR
SELECT FIRST_NAME, LAST_NAME, SALARY
FROM EMPLOYEES
WHERE FIRST_NAME >= 'Julia'
AND   FIRST_NAME >= 'John';

--any
SELECT FIRST_NAME, LAST_NAME, SALARY
FROM EMPLOYEES
WHERE FIRST_NAME = ANY('Julia', 'John');

SELECT FIRST_NAME, LAST_NAME, SALARY
FROM EMPLOYEES
WHERE SALARY = ANY (SELECT SALARY FROM EMPLOYEES
                      WHERE JOB_ID = 'IT_PROG');

EXPLAIN PLAN FOR
SELECT FIRST_NAME, LAST_NAME, SALARY
FROM EMPLOYEES
WHERE FIRST_NAME = ANY('Julia', 'John');

                      
--in
SELECT FIRST_NAME, LAST_NAME, SALARY
FROM EMPLOYEES
WHERE FIRST_NAME in ('Julia', 'John');

SELECT FIRST_NAME, LAST_NAME, SALARY
FROM EMPLOYEES
WHERE SALARY in (SELECT SALARY FROM EMPLOYEES
                  WHERE JOB_ID = 'IT_PROG');

--not in
SELECT FIRST_NAME, LAST_NAME, SALARY
FROM EMPLOYEES
WHERE FIRST_NAME not in ('Julia', 'John');

SELECT FIRST_NAME, LAST_NAME, MANAGER_ID
FROM EMPLOYEES
WHERE MANAGER_ID IS NULL;

SELECT FIRST_NAME, LAST_NAME, MANAGER_ID
FROM EMPLOYEES
WHERE MANAGER_ID not in (120, 100);

--exists
SELECT FIRST_NAME, LAST_NAME, SALARY
FROM EMPLOYEES
WHERE EXISTS (SELECT 1 FROM DUAL);

SELECT FIRST_NAME, LAST_NAME, SALARY
FROM EMPLOYEES
WHERE NOT EXISTS (SELECT 1 FROM DUAL);

SELECT FIRST_NAME, LAST_NAME, SALARY, JOB_ID
FROM EMPLOYEES A
WHERE EXISTS (SELECT 1 FROM DUAL B
               WHERE A.JOB_ID = 'IT_PROG');
               
SELECT FIRST_NAME, LAST_NAME, SALARY, JOB_ID
FROM EMPLOYEES A
WHERE JOB_ID IN ('IT_PROG');
               

SELECT FIRST_NAME, LAST_NAME, SALARY, JOB_ID
FROM EMPLOYEES A
WHERE NOT EXISTS (SELECT 1 FROM DUAL B
                   WHERE A.JOB_ID = 'IT_PROG');
                   
--between
EXPLAIN PLAN FOR
SELECT FIRST_NAME, LAST_NAME, SALARY
FROM EMPLOYEES
WHERE SALARY BETWEEN 3200 AND 9000;

SELECT *
FROM PLAN_TABLE;

EXPLAIN PLAN FOR
SELECT FIRST_NAME, LAST_NAME, SALARY
FROM EMPLOYEES
WHERE SALARY NOT BETWEEN 3200 AND 9000;

SELECT *
FROM PLAN_TABLE;

--like
SELECT FIRST_NAME, LAST_NAME, SALARY
FROM EMPLOYEES
WHERE FIRST_NAME LIKE 'G_ra_d';

SELECT FIRST_NAME, LAST_NAME, SALARY
FROM EMPLOYEES
WHERE FIRST_NAME LIKE 'K%y';

