-- 
-- SALARY ϱ
SELECT SUM(SALARY), COUNT(*)
FROM EMPLOYEES;

SELECT EMPLOYEE_ID, FIRST_NAME, JOB_ID, 691416 / 107 AS AVG
FROM EMPLOYEES;

SELECT *
FROM EMPLOYEES;


--ο  Է
INSERT INTO EMPLOYEES (EMPLOYEE_ID, FIRST_NAME, LAST_NAME, 
   EMAIL, PHONE_NUMBER, HIRE_DATE, JOB_ID, SALARY,  
   MANAGER_ID, DEPARTMENT_ID) 
VALUES ( 999, 'TaeHo', 'Lee',
 'SAAKHAN', '555.555.555', TO_DATE('20131101', 'YYYYMMDD'),
 'IT_PROG', 12000, 102, 60);
 
-- հ Ҽ ִ
SELECT EMPLOYEE_ID, FIRST_NAME, JOB_ID, SALARY,
       (SELECT SUM(SALARY) FROM EMPLOYEES) AS SUM,
       (SELECT COUNT(*) FROM EMPLOYEES) AS CNT,
       (SELECT SUM(SALARY) FROM EMPLOYEES)
       / (SELECT COUNT(*) FROM EMPLOYEES) AS AVG
FROM EMPLOYEES;

SELECT EMPLOYEE_ID, FIRST_NAME, JOB_ID, SALARY
FROM EMPLOYEES
WHERE SALARY > (SELECT AVG(SALARY) FROM EMPLOYEES);

--ERROR
SELECT EMPLOYEE_ID, FIRST_NAME, JOB_ID, (SELECT SALARY FROM EMPLOYEES)
FROM EMPLOYEES;

-- Ǵ
--1ϱ׷Լ . 
SELECT EMPLOYEE_ID, FIRST_NAME, JOB_ID, (SELECT MAX(SALARY) FROM EMPLOYEES)
FROM EMPLOYEES;

--2.PK  
SELECT EMPLOYEE_ID, FIRST_NAME, JOB_ID, (SELECT SALARY FROM EMPLOYEES 
                                          WHERE EMPLOYEE_ID = 101)
FROM EMPLOYEES;

--3.ROWNUM = 1  
SELECT EMPLOYEE_ID, FIRST_NAME, JOB_ID, (SELECT SALARY FROM EMPLOYEES 
                                          WHERE ROWNUM = 1)
FROM EMPLOYEES;

-- ÷ 

SELECT EMPLOYEE_ID, START_DATE, END_DATE, JOB_ID, DEPARTMENT_ID
FROM JOB_HISTORY
WHERE (EMPLOYEE_ID, START_DATE) = (SELECT EMPLOYEE_ID, HIRE_DATE FROM EMPLOYEES
                                    WHERE EMPLOYEE_ID = 102);
                                    
SELECT EMPLOYEE_ID, FIRST_NAME, JOB_ID,  (SELECT EMPLOYEE_ID, HIRE_DATE FROM EMPLOYEES
                                           WHERE EMPLOYEE_ID = 102)
FROM EMPLOYEES;

-- 
SELECT FIRST_NAME, SALARY
 FROM EMPLOYEES
WHERE JOB_ID = ANY (SELECT JOB_ID FROM JOBS);

SELECT EMPLOYEE_ID, START_DATE, END_DATE, JOB_ID, DEPARTMENT_ID
FROM JOB_HISTORY
WHERE (EMPLOYEE_ID, START_DATE) IN (SELECT EMPLOYEE_ID, HIRE_DATE FROM EMPLOYEES);

SELECT A.EMPLOYEE_ID, A.FIRST_NAME, A.JOB_ID, B.SAL_SUM
FROM EMPLOYEES A, (SELECT JOB_ID, SUM(SALARY) AS SAL_SUM FROM EMPLOYEES
                    GROUP BY JOB_ID) B
WHERE A.JOB_ID = B.JOB_ID;

-- 
SELECT FIRST_NAME, SALARY, (SELECT AVG(SALARY) FROM EMPLOYEES C
                             WHERE A.JOB_ID = C.JOB_ID)
 FROM EMPLOYEES A
WHERE SALARY > (SELECT AVG(SALARY) 
                  FROM EMPLOYEES B 
                 WHERE A.JOB_ID = B.JOB_ID);

