--帧 
--CASE
-- Į   
SELECT EMPLOYEE_ID, FIRST_NAME, PHONE_NUMBER,
       CASE SUBSTR(PHONE_NUMBER, 1, 3)
       WHEN '515' THEN ''
       WHEN '590' THEN ''
       WHEN '659' THEN 'λ'
       WHEN '603' THEN ''
       ELSE 'Ÿ' END AS AREA
FROM EMPLOYEES;

--  ǿ  帧 
SELECT EMPLOYEE_ID, FIRST_NAME, PHONE_NUMBER,
       CASE WHEN SUBSTR(PHONE_NUMBER, 1, 3) >= '515' 
             AND SUBSTR(PHONE_NUMBER, 1, 3) < '590' THEN ''
            WHEN SUBSTR(PHONE_NUMBER, 1, 3) = '590' THEN ''
            WHEN SUBSTR(PHONE_NUMBER, 1, 3) = '659' THEN 'λ'
            WHEN SUBSTR(PHONE_NUMBER, 1, 3) <= '603' THEN ''
            ELSE 'Ÿ' END AS AREA
FROM EMPLOYEES;

--DECODE
SELECT EMPLOYEE_ID, FIRST_NAME, PHONE_NUMBER,
      DECODE (SUBSTR(PHONE_NUMBER, 1, 3),
      '515', '', '590', '', '659', 'λ',
      '603', '', 'Ÿ') AS AREA
FROM EMPLOYEES;
 
--NVL2
SELECT EMPLOYEE_ID, FIRST_NAME, MANAGER_ID
     , NVL(MANAGER_ID, EMPLOYEE_ID)
     , NVL2(MANAGER_ID, '', '')
FROM EMPLOYEES;


--TOP N 
-- Ŭ 12c  ó
[ OFFSET offset { ROW | ROWS } ]
[ FETCH { FIRST | NEXT } 
[ { rowcount | percent PERCENT } ]
{ ROW | ROWS } { ONLY | WITH TIES } ]

SELECT EMPLOYEE_ID, FIRST_NAME, PHONE_NUMBER
FROM EMPLOYEES
ORDER BY FIRST_NAME
OFFSET 2 ROWS
FETCH FIRST 2 ROWS WITH TIES;

SELECT EMPLOYEE_ID, FIRST_NAME, PHONE_NUMBER
FROM EMPLOYEES
ORDER BY FIRST_NAME
OFFSET 5 ROWS
FETCH FIRST 5 PERCENT ROWS WITH TIES;

--ROWNUM ̿ ( )
SELECT ROWNUM, EMPLOYEE_ID, FIRST_NAME, PHONE_NUMBER
FROM
(
SELECT ROWNUM, EMPLOYEE_ID, FIRST_NAME, PHONE_NUMBER
FROM EMPLOYEES
ORDER BY FIRST_NAME
)
WHERE ROWNUM < 6;

--ERROR
SELECT ROWNUM, EMPLOYEE_ID, FIRST_NAME, PHONE_NUMBER
FROM
(
SELECT ROWNUM, EMPLOYEE_ID, FIRST_NAME, PHONE_NUMBER
FROM EMPLOYEES
ORDER BY FIRST_NAME
)
WHERE ROWNUM >= 3 AND ROWNUM <= 9;

SELECT ROWNUM, EMPLOYEE_ID, FIRST_NAME, PHONE_NUMBER
FROM
(
SELECT ROWNUM, EMPLOYEE_ID, FIRST_NAME, PHONE_NUMBER
FROM EMPLOYEES
ORDER BY FIRST_NAME
)
WHERE ROWNUM <= 3;

--¡ ó
SELECT ROWNUM, ROW_CNT, EMPLOYEE_ID, FIRST_NAME, PHONE_NUMBER
FROM
(
SELECT ROWNUM AS ROW_CNT, EMPLOYEE_ID, FIRST_NAME, PHONE_NUMBER
FROM
(
SELECT ROWNUM, EMPLOYEE_ID, FIRST_NAME, PHONE_NUMBER
FROM EMPLOYEES
ORDER BY FIRST_NAME
)
WHERE ROWNUM < 100
)
WHERE ROW_CNT BETWEEN 3 AND 9;


--мԼ ̿ 
SELECT ROWNUM, ROW_CNT, EMPLOYEE_ID, FIRST_NAME, PHONE_NUMBER
FROM
(
SELECT EMPLOYEE_ID, FIRST_NAME, PHONE_NUMBER
     , ROW_NUMBER() OVER(ORDER BY FIRST_NAME) AS ROW_CNT
FROM EMPLOYEES
)
WHERE ROW_CNT < 6;

SELECT ROWNUM, ROW_CNT, EMPLOYEE_ID, FIRST_NAME, PHONE_NUMBER
FROM
(
SELECT EMPLOYEE_ID, FIRST_NAME, PHONE_NUMBER
     , ROW_NUMBER() OVER(ORDER BY FIRST_NAME) AS ROW_CNT
FROM EMPLOYEES
)
WHERE ROW_CNT BETWEEN 3 AND 9;


--мԼ
--
SELECT FIRST_NAME, JOB_ID, SALARY
     , RANK() OVER (ORDER BY SALARY DESC) AS RANK
     , DENSE_RANK() OVER (ORDER BY SALARY DESC) AS DENSE_RANK
     , ROW_NUMBER() OVER (ORDER BY SALARY DESC) AS ROW_NUMBER
FROM EMPLOYEES
ORDER BY SALARY DESC;

--ȿ 
SELECT FIRST_NAME, JOB_ID, SALARY
     , RANK() OVER (PARTITION BY JOB_ID ORDER BY SALARY DESC) AS RANK
     , DENSE_RANK() OVER (PARTITION BY JOB_ID ORDER BY SALARY DESC) AS DENSE_RANK
     , ROW_NUMBER() OVER (PARTITION BY JOB_ID ORDER BY SALARY DESC) AS ROW_NUMBER
FROM EMPLOYEES         
ORDER BY JOB_ID, SALARY DESC;

--
--ü
SELECT FIRST_NAME, JOB_ID, SALARY
     , SUM(SALARY) OVER () AS TOT_SUM
     , COUNT(*) OVER () AS TOT_CNT
     , AVG(SALARY) OVER () AS TOT_AVG
     , MAX(SALARY) OVER () AS TOT_MAX
     , MIN(SALARY) OVER () AS TOT_MIN
FROM EMPLOYEES  
ORDER BY JOB_ID, FIRST_NAME;

--׷ȿ 
SELECT FIRST_NAME, JOB_ID, SALARY
     , SUM(SALARY) OVER (PARTITION BY JOB_ID) PART_SAL
     , COUNT(*) OVER (PARTITION BY JOB_ID) PART_CNT
     , AVG(SALARY) OVER (PARTITION BY JOB_ID) PART_AVG
     , MAX(SALARY) OVER (PARTITION BY JOB_ID) PART_MAX
     , MIN(SALARY) OVER (PARTITION BY JOB_ID) PART_MIN
FROM EMPLOYEES  
ORDER BY JOB_ID, FIRST_NAME;

--
SELECT FIRST_NAME, JOB_ID, SALARY
     , FIRST_VALUE(FIRST_NAME) OVER (ORDER BY FIRST_NAME) FIRST_SAL
     , LAST_VALUE(FIRST_NAME) OVER (ORDER BY FIRST_NAME) LAST_SAL
     , LAG(FIRST_NAME) OVER (ORDER BY FIRST_NAME) LAG_SAL
     , LEAD(FIRST_NAME) OVER (ORDER BY FIRST_NAME) LEAD_SAL
FROM EMPLOYEES  
ORDER BY FIRST_NAME;

--׷ȿ 
SELECT FIRST_NAME, JOB_ID, SALARY
     , FIRST_VALUE(FIRST_NAME) OVER (PARTITION BY JOB_ID ORDER BY FIRST_NAME) FIRST_SAL
     , LAST_VALUE(FIRST_NAME) OVER (PARTITION BY JOB_ID ORDER BY FIRST_NAME) LAST_SAL
     , LAG(FIRST_NAME) OVER (PARTITION BY JOB_ID ORDER BY FIRST_NAME) LAG_SAL
     , LEAD(FIRST_NAME) OVER (PARTITION BY JOB_ID ORDER BY FIRST_NAME) LEAD_SAL
FROM EMPLOYEES  
ORDER BY JOB_ID, FIRST_NAME;

--
-- CUME_DIST() : üǼ Ǽ      1 ȴ
-- PERCENT_RANK() :      ° 0,  1 ̴.
-- NTILE() : üǼ ڷ   ǥ
--               üǼ  1  ڷ ǥȴ.
-- RATIO_TO_REPORT(Į) : ü հ ش   ġ 1 ȴ
SELECT FIRST_NAME, JOB_ID, SALARY
     , CUME_DIST() OVER (ORDER BY FIRST_NAME) AS CUME_SAL
     , PERCENT_RANK() OVER (ORDER BY FIRST_NAME) AS PERC_SAL
     , NTILE(10) OVER (ORDER BY FIRST_NAME) AS NTILE_SAL
     , RATIO_TO_REPORT(SALARY) OVER () AS RATIO_SAL
FROM EMPLOYEES
ORDER BY FIRST_NAME;

--׷ȿ 
SELECT FIRST_NAME, JOB_ID, SALARY
     , CUME_DIST() OVER (PARTITION BY JOB_ID ORDER BY FIRST_NAME) AS CUME_SAL
     , PERCENT_RANK() OVER (PARTITION BY JOB_ID ORDER BY FIRST_NAME) AS PERC_SAL
     , NTILE(10) OVER (PARTITION BY JOB_ID ORDER BY FIRST_NAME) AS NTILE_SAL
     , RATIO_TO_REPORT(SALARY) OVER (PARTITION BY JOB_ID) AS RATIO_SAL
FROM EMPLOYEES
ORDER BY FIRST_NAME;

--   м Լ
SELECT FIRST_NAME, JOB_ID, SALARY
     , CORR(SYSDATE - HIRE_DATE, SALARY) OVER (PARTITION BY JOB_ID) AS COR_SAL
     , COVAR_POP(SYSDATE - HIRE_DATE, SALARY) OVER (PARTITION BY JOB_ID) AS CORP_SAL
     , COVAR_SAMP(SYSDATE - HIRE_DATE, SALARY) OVER (PARTITION BY JOB_ID) AS CORS_SAL
     , STDDEV(SALARY) OVER (ORDER BY HIRE_DATE) AS STD_SAL
     , STDDEV_POP(SALARY) OVER (ORDER BY HIRE_DATE) AS STDP_SAL
     , STDDEV_SAMP(SALARY) OVER (PARTITION BY JOB_ID) AS STDS_SAL
     , VARIANCE(SALARY) OVER (PARTITION BY JOB_ID) AS VAR_SAL
     , VAR_POP(SALARY) OVER (PARTITION BY JOB_ID) AS VARP_SAL
     , VAR_SAMP(SALARY) OVER (PARTITION BY JOB_ID) AS VARS_SAL
     , REGR_SLOPE(SYSDATE - HIRE_DATE, SALARY) OVER (PARTITION BY JOB_ID) AS SLOPE_SAL
     , REGR_INTERCEPT(SYSDATE - HIRE_DATE, SALARY) OVER (PARTITION BY JOB_ID) AS INTCPT_SAL
     , REGR_COUNT(SYSDATE - HIRE_DATE, SALARY) OVER (PARTITION BY JOB_ID) AS COUNT_SAL
     , REGR_R2(SYSDATE - HIRE_DATE, SALARY) OVER (PARTITION BY JOB_ID) AS R2_SAL
     , REGR_AVGX(SYSDATE - HIRE_DATE, SALARY) OVER (PARTITION BY JOB_ID) AS AVGX_SAL
     , REGR_AVGY(SYSDATE - HIRE_DATE, SALARY) OVER (PARTITION BY JOB_ID) AS AVGY_SAL
     , REGR_SXX(SYSDATE - HIRE_DATE, SALARY) OVER (PARTITION BY JOB_ID) AS SXX_SAL
     , REGR_SYY(SYSDATE - HIRE_DATE, SALARY) OVER (PARTITION BY JOB_ID) AS SYY_SAL
     , REGR_SXY(SYSDATE - HIRE_DATE, SALARY) OVER (PARTITION BY JOB_ID) AS SXY_SAL
FROM EMPLOYEES  
ORDER BY JOB_ID, FIRST_NAME;

--WINDOWING
-- ̿Ͽ ϱ windowing 
SELECT FIRST_NAME, JOB_ID, SALARY
     , FIRST_VALUE(FIRST_NAME) OVER (ORDER BY FIRST_NAME) AS FIRST_SAL
     , LAST_VALUE(FIRST_NAME) OVER (ORDER BY FIRST_NAME) AS LAST_SAL
     , LAG(FIRST_NAME) OVER (ORDER BY FIRST_NAME) AS LAG_SAL
     , LEAD(FIRST_NAME) OVER (ORDER BY FIRST_NAME) AS LEAD_SAL
FROM EMPLOYEES  
ORDER BY FIRST_NAME;

--ERROR  Ȯ   ʿ.
SELECT FIRST_NAME, JOB_ID, SALARY
     , FIRST_VALUE(FIRST_NAME) OVER (ORDER BY FIRST_NAME) AS FIRST_SAL
     , LAST_VALUE(FIRST_NAME) OVER (ORDER BY FIRST_NAME) AS LAST_SAL
     , LAG(FIRST_NAME) OVER (ORDER BY FIRST_NAME ROWS UNBOUNDED PRECEDING) AS LAG_SAL
     , LEAD(FIRST_NAME) OVER (ORDER BY FIRST_NAME ROWS UNBOUNDED PRECEDING) AS LEAD_SAL
FROM EMPLOYEES  
ORDER BY FIRST_NAME;

--ROWS   
SELECT FIRST_NAME, JOB_ID, SALARY
     , FIRST_VALUE(FIRST_NAME) OVER (ORDER BY FIRST_NAME
       ROWS BETWEEN UNBOUNDED PRECEDING AND UNBOUNDED FOLLOWING) AS UN_FIRST
     , LAST_VALUE(FIRST_NAME) OVER (ORDER BY FIRST_NAME
       ROWS BETWEEN UNBOUNDED PRECEDING AND UNBOUNDED FOLLOWING) AS UN_LAST
     , FIRST_VALUE(FIRST_NAME) OVER (ORDER BY FIRST_NAME
       ROWS BETWEEN UNBOUNDED PRECEDING AND CURRENT ROW) AS CUR_FIRST
     , LAST_VALUE(FIRST_NAME) OVER (ORDER BY FIRST_NAME
       ROWS BETWEEN UNBOUNDED PRECEDING AND CURRENT ROW) AS CUR_LAST
     , FIRST_VALUE(FIRST_NAME) OVER (ORDER BY FIRST_NAME
       ROWS BETWEEN 3 PRECEDING AND 3 FOLLOWING) AS FIX_FIRST
     , LAST_VALUE(FIRST_NAME) OVER (ORDER BY FIRST_NAME
       ROWS BETWEEN 3 PRECEDING AND 3 FOLLOWING) AS FIX_LAST
FROM EMPLOYEES  
ORDER BY FIRST_NAME;


--RANGE   
--ERROR      
SELECT FIRST_NAME, JOB_ID, SALARY
     , FIRST_VALUE(FIRST_NAME) OVER (ORDER BY FIRST_NAME
       RANGE BETWEEN UNBOUNDED PRECEDING AND UNBOUNDED FOLLOWING) AS UN_FIRST
     , LAST_VALUE(FIRST_NAME) OVER (ORDER BY FIRST_NAME
       RANGE BETWEEN UNBOUNDED PRECEDING AND UNBOUNDED FOLLOWING) AS UN_LAST
     , FIRST_VALUE(FIRST_NAME) OVER (ORDER BY FIRST_NAME
       RANGE BETWEEN UNBOUNDED PRECEDING AND CURRENT ROW) AS CUR_FIRST
     , LAST_VALUE(FIRST_NAME) OVER (ORDER BY FIRST_NAME
       RANGE BETWEEN UNBOUNDED PRECEDING AND CURRENT ROW) AS CUR_LAST
     , FIRST_VALUE(FIRST_NAME) OVER (ORDER BY FIRST_NAME
       RANGE BETWEEN 3 PRECEDING AND 3 FOLLOWING) AS FIX_FIRST
     , LAST_VALUE(FIRST_NAME) OVER (ORDER BY FIRST_NAME
       RANGE BETWEEN 3 PRECEDING AND 3 FOLLOWING) AS FIX_LAST
FROM EMPLOYEES  
ORDER BY FIRST_NAME;

--  ڷῩ Ѵ
SELECT FIRST_NAME, JOB_ID, SALARY
     , ROW_NUMBER() OVER (ORDER BY SALARY) AS ROW_CNT
     , COUNT(*) OVER (ORDER BY SALARY 
       RANGE BETWEEN UNBOUNDED PRECEDING  AND UNBOUNDED FOLLOWING) AS UN_SAL
     , COUNT(*) OVER (ORDER BY SALARY
       RANGE BETWEEN UNBOUNDED PRECEDING  AND CURRENT ROW) AS CUR_SAL
     , COUNT(*) OVER (ORDER BY SALARY
       RANGE BETWEEN 500 PRECEDING AND 500 FOLLOWING) AS FIX_SAL
FROM EMPLOYEES
ORDER BY SALARY;

