-- 
-- SALARY ϱ
SELECT SUM(SALARY), COUNT(*)
FROM EMPLOYEES;

SELECT EMPLOYEE_ID, FIRST_NAME, JOB_ID, 691416 / 107 AS AVG
FROM EMPLOYEES;

SELECT *
FROM EMPLOYEES;


--ο  Է
INSERT INTO EMPLOYEES (EMPLOYEE_ID, FIRST_NAME, LAST_NAME, 
   EMAIL, PHONE_NUMBER, HIRE_DATE, JOB_ID, SALARY,  
   MANAGER_ID, DEPARTMENT_ID) 
VALUES ( 999, 'TaeHo', 'Lee',
 'SAAKHAN', '555.555.555', TO_DATE('20131101', 'YYYYMMDD'),
 'IT_PROG', 12000, 102, 60);
 
-- հ Ҽ ִ
SELECT EMPLOYEE_ID, FIRST_NAME, JOB_ID, SALARY,
       (SELECT SUM(SALARY) FROM EMPLOYEES) AS SUM,
       (SELECT COUNT(*) FROM EMPLOYEES) AS CNT,
       (SELECT SUM(SALARY) FROM EMPLOYEES)
       / (SELECT COUNT(*) FROM EMPLOYEES) AS AVG
FROM EMPLOYEES;

SELECT EMPLOYEE_ID, FIRST_NAME, JOB_ID, SALARY
FROM EMPLOYEES
WHERE SALARY > (SELECT AVG(SALARY) FROM EMPLOYEES);

--ERROR
SELECT EMPLOYEE_ID, FIRST_NAME, JOB_ID, (SELECT SALARY FROM EMPLOYEES)
FROM EMPLOYEES;

-- Ǵ
--1ϱ׷Լ . 
SELECT EMPLOYEE_ID, FIRST_NAME, JOB_ID, (SELECT MAX(SALARY) FROM EMPLOYEES)
FROM EMPLOYEES;

--2.PK  
SELECT EMPLOYEE_ID, FIRST_NAME, JOB_ID, (SELECT SALARY FROM EMPLOYEES 
                                          WHERE EMPLOYEE_ID = 101)
FROM EMPLOYEES;

--3.ROWNUM = 1  
SELECT EMPLOYEE_ID, FIRST_NAME, JOB_ID, (SELECT SALARY FROM EMPLOYEES 
                                          WHERE ROWNUM = 1)
FROM EMPLOYEES;

-- ÷ 

SELECT EMPLOYEE_ID, START_DATE, END_DATE, JOB_ID, DEPARTMENT_ID
FROM JOB_HISTORY
WHERE (EMPLOYEE_ID, START_DATE) = (SELECT EMPLOYEE_ID, HIRE_DATE FROM EMPLOYEES
                                    WHERE EMPLOYEE_ID = 102);
                                    
SELECT EMPLOYEE_ID, FIRST_NAME, JOB_ID,  (SELECT EMPLOYEE_ID, HIRE_DATE FROM EMPLOYEES
                                           WHERE EMPLOYEE_ID = 102)
FROM EMPLOYEES;

-- 
SELECT FIRST_NAME, SALARY
 FROM EMPLOYEES
WHERE JOB_ID = ANY (SELECT JOB_ID FROM JOBS);

SELECT EMPLOYEE_ID, START_DATE, END_DATE, JOB_ID, DEPARTMENT_ID
FROM JOB_HISTORY
WHERE (EMPLOYEE_ID, START_DATE) IN (SELECT EMPLOYEE_ID, HIRE_DATE FROM EMPLOYEES);

SELECT A.EMPLOYEE_ID, A.FIRST_NAME, A.JOB_ID, B.SAL_SUM
FROM EMPLOYEES A, (SELECT JOB_ID, SUM(SALARY) AS SAL_SUM FROM EMPLOYEES
                    GROUP BY JOB_ID) B
WHERE A.JOB_ID = B.JOB_ID;

-- 
SELECT FIRST_NAME, SALARY, (SELECT AVG(SALARY) FROM EMPLOYEES C
                             WHERE A.JOB_ID = C.JOB_ID)
 FROM EMPLOYEES A
WHERE SALARY > (SELECT AVG(SALARY) 
                  FROM EMPLOYEES B 
                 WHERE A.JOB_ID = B.JOB_ID);

--帧 
--CASE
SELECT EMPLOYEE_ID, FIRST_NAME, PHONE_NUMBER,
       CASE SUBSTR(PHONE_NUMBER, 1, 3)
       WHEN '515' THEN ''
       WHEN '590' THEN ''
       WHEN '659' THEN 'λ'
       WHEN '603' THEN ''
       ELSE 'Ÿ' END AS AREA
FROM EMPLOYEES;

SELECT EMPLOYEE_ID, FIRST_NAME, PHONE_NUMBER,
       CASE WHEN SUBSTR(PHONE_NUMBER, 1, 3) <= '515' THEN ''
            WHEN SUBSTR(PHONE_NUMBER, 1, 3) = '590' THEN ''
            WHEN SUBSTR(PHONE_NUMBER, 1, 3) = '659' THEN 'λ'
            WHEN SUBSTR(PHONE_NUMBER, 1, 3) >= '603' THEN ''
            ELSE 'Ÿ' END AS AREA
FROM EMPLOYEES;

--DECODE
SELECT EMPLOYEE_ID, FIRST_NAME, PHONE_NUMBER,
      DECODE (SUBSTR(PHONE_NUMBER, 1, 3),
      '515', '', '590', '', '659', 'λ',
      '603', '', 'Ÿ') AS AREA
FROM EMPLOYEES;
 


            



SELECT EMPLOYEE_ID, FIRST_NAME, MANAGER_ID, NVL(MANAGER_ID, EMPLOYEE_ID), NVL2(MANAGER_ID, '', '')
FROM EMPLOYEES;



SELECT EMPLOYEE_ID, FIRST_NAME, PHONE_NUMBER
FROM EMPLOYEES
ORDER BY FIRST_NAME
--OFFSET 5 ROW
FETCH first 5 ROW ONLY;


SELECT *
FROM
(
SELECT EMPLOYEE_ID, FIRST_NAME, PHONE_NUMBER
FROM EMPLOYEES
ORDER BY FIRST_NAME
)
WHERE ROWNUM < 6;

SELECT *
FROM
(
SELECT EMPLOYEE_ID, FIRST_NAME, PHONE_NUMBER, ROW_NUMBER() OVER(ORDER BY FIRST_NAME) AS RANK
FROM EMPLOYEES
)
WHERE RANK < 6;


SELECT FIRST_NAME, JOB_ID, SALARY,
       SUM(SALARY) OVER (PARTITION BY JOB_ID, DEPARTMENT_ID) J_SAL,
       SUM(SALARY) OVER (PARTITION BY DEPARTMENT_ID) D_SAL,       
       SUM(SALARY) OVER (ORDER BY JOB_ID, FIRST_NAME ROWS 20 PRECEDING ) J_SAL_W1,
       SUM(SALARY) OVER (ORDER BY SALARY RANGE BETWEEN (SALARY/2) PRECEDING AND UNBOUNDED FOLLOWING ) J_SAL_W2,
       LAG(FIRST_NAME) OVER (ORDER BY FIRST_NAME) LAG_NM,
       RATIO_TO_REPORT(SALARY) OVER (PARTITION BY DEPARTMENT_ID) R1,
       ROW_NUMBER () OVER (ORDER BY SALARY DESC)
  FROM EMPLOYEES  
  ORDER BY JOB_ID, FIRST_NAME;


SELECT FIRST_NAME, JOB_ID, SALARY,
       SUM(SALARY) OVER (ORDER BY FIRST_NAME ROWS UNBOUNDED PRECEDING ) J_SAL_W1,
       SUM(SALARY) OVER (ORDER BY FIRST_NAME ROWS CURRENT ROW) J_SAL_W2,
       SUM(SALARY) OVER (ORDER BY FIRST_NAME ROWS 3 PRECEDING) J_SAL_W3,        
       SUM(SALARY) OVER (ORDER BY FIRST_NAME ROWS BETWEEN 1 FOLLOWING AND 2 FOLLOWING ) J_SAL_W4, 
       SUM(SALARY) OVER (ORDER BY SALARY RANGE UNBOUNDED PRECEDING ) J_SAL_W1,
       SUM(SALARY) OVER (ORDER BY SALARY RANGE CURRENT ROW) J_SAL_W2,
       SUM(SALARY) OVER (ORDER BY SALARY RANGE (SALARY/3) PRECEDING) J_SAL_W3,        
       SUM(SALARY) OVER (ORDER BY SALARY RANGE BETWEEN (SALARY/3) FOLLOWING AND (SALARY/2) FOLLOWING ) J_SAL_W4, 
       ROW_NUMBER () OVER (ORDER BY SALARY DESC)
  FROM EMPLOYEES  
  ORDER BY FIRST_NAME;


SELECT FIRST_NAME, JOB_ID, SALARY, SALARY / 5, SUM(SALARY/5) OVER (PARTITION BY JOB_ID), 
       SUM(SALARY/ 5) OVER (PARTITION BY JOB_ID ORDER BY SALARY RANGE UNBOUNDED PRECEDING ) J_SAL_WW1,
       COUNT(*) OVER (PARTITION BY JOB_ID ORDER BY SALARY RANGE UNBOUNDED PRECEDING ) J_SAL_W1,
       COUNT(*) OVER (PARTITION BY JOB_ID ORDER BY SALARY RANGE CURRENT ROW) J_SAL_W2,
       COUNT(*) OVER (PARTITION BY JOB_ID ORDER BY SALARY RANGE 3000 PRECEDING) J_SAL_W3,        
       FIRST_VALUE(SALARY) OVER (PARTITION BY JOB_ID ORDER BY SALARY RANGE BETWEEN UNBOUNDED PRECEDING AND 3000 PRECEDING ) J_SAL_W4,    
       COUNT(*) OVER (PARTITION BY JOB_ID ORDER BY SALARY RANGE BETWEEN 3000 PRECEDING AND CURRENT ROW ) J_SAL_W5,       
       COUNT(*) OVER (PARTITION BY JOB_ID ORDER BY SALARY RANGE BETWEEN CURRENT ROW AND 300 FOLLOWING) J_SAL_W6,
       COUNT(*) OVER (PARTITION BY JOB_ID ORDER BY SALARY RANGE BETWEEN CURRENT ROW AND UNBOUNDED FOLLOWING) J_SAL_W7
  FROM EMPLOYEES
 WHERE JOB_ID = ANY ('IT_PROG')
  ORDER BY JOB_ID,  SALARY
  ;


SELECT FIRST_NAME, JOB_ID, CUME_DIST() OVER (PARTITION BY JOB_ID ORDER BY SALARY), NTILE(4) OVER (ORDER BY JOB_ID),
       CORR (SALARY, SALARY / 2) OVER (PARTITION BY JOB_ID ORDER BY SALARY),
       COUNT(*) OVER (PARTITION BY JOB_ID ORDER BY SALARY RANGE UNBOUNDED PRECEDING ) J_SAL_W1,
       COUNT(*) OVER (PARTITION BY JOB_ID ORDER BY SALARY RANGE CURRENT ROW) J_SAL_W2,
       COUNT(*) OVER (PARTITION BY JOB_ID ORDER BY SALARY RANGE 3000 PRECEDING) J_SAL_W3,        
       FIRST_VALUE(SALARY) OVER (PARTITION BY JOB_ID ORDER BY SALARY RANGE BETWEEN UNBOUNDED PRECEDING AND 3000 PRECEDING ) J_SAL_W4,    
       COUNT(*) OVER (PARTITION BY JOB_ID ORDER BY SALARY RANGE BETWEEN 3000 PRECEDING AND CURRENT ROW ) J_SAL_W5,       
       COUNT(*) OVER (PARTITION BY JOB_ID ORDER BY SALARY RANGE BETWEEN CURRENT ROW AND 300 FOLLOWING) J_SAL_W6,
       COUNT(*) OVER (PARTITION BY JOB_ID ORDER BY SALARY RANGE BETWEEN CURRENT ROW AND UNBOUNDED FOLLOWING) J_SAL_W7
  FROM EMPLOYEES
-- WHERE JOB_ID = ANY ('IT_PROG')
  ORDER BY JOB_ID,  SALARY
  ;


SELECT JOB_ID, MIN_SALARY, MAX_SALARY, CORR (MIN_SALARY, MAX_SALARY) OVER (ORDER BY JOB_ID),
       COVAR_POP (MAX_SALARY, MIN_SALARY) OVER (ORDER BY JOB_ID), 
       COVAR_SAMP (MAX_SALARY, MIN_SALARY) OVER (ORDER BY JOB_ID),
       STDDEV(MIN_SALARY) OVER (ORDER BY JOB_ID)
     , VARIANCE(MIN_SALARY) OVER (ORDER BY JOB_ID)
     , VAR_POP(MIN_SALARY) OVER (ORDER BY JOB_ID)
     , VAR_SAMP(MIN_SALARY) OVER (ORDER BY JOB_ID)
     , REGR_SLOPE(MAX_SALARY, MIN_SALARY) OVER (ORDER BY JOB_ID)
     , REGR_INTERCEPT(MAX_SALARY, MIN_SALARY) OVER (ORDER BY JOB_ID)   
     , REGR_COUNT(MAX_SALARY, MIN_SALARY) OVER (ORDER BY JOB_ID) 
     , REGR_R2(MAX_SALARY, MIN_SALARY) OVER (ORDER BY JOB_ID) 
     , REGR_AVGX(MAX_SALARY, MIN_SALARY) OVER (ORDER BY JOB_ID) 
     , REGR_AVGY(MAX_SALARY, MIN_SALARY) OVER (ORDER BY JOB_ID) 
     , REGR_SXX(MAX_SALARY, MIN_SALARY) OVER (ORDER BY JOB_ID) 
     , REGR_SYY(MAX_SALARY, MIN_SALARY) OVER (ORDER BY JOB_ID) 
     , REGR_SXY(MAX_SALARY, MIN_SALARY) OVER (ORDER BY JOB_ID) 
FROM JOBS
ORDER BY JOB_ID


SELECT deptno, empno, sal,
Count(*) OVER (PARTITION BY deptno ORDER BY sal RANGE
BETWEEN UNBOUNDED PRECEDING AND (sal/2) PRECEDING) CNT_LT_HALF,
COUNT(*) OVER (PARTITION BY deptno ORDER BY sal RANGE
BETWEEN (sal/2) FOLLOWING AND UNBOUNDED FOLLOWING) CNT_MT_HALF
FROM emp
WHERE deptno IN (20, 30)
ORDER BY deptno, sal

SELECT JOB_ID
FROM EMPLOYEES
INTERSECT
SELECT JOB_ID
FROM JOBS;


SELECT DISTINCT A.JOB_ID
FROM EMPLOYEES A, JOBS B
WHERE A.JOB_ID = B.JOB_ID;



SELECT EMPLOYEE_ID
FROM EMPLOYEES
MINUS
SELECT MANAGER_ID
FROM EMPLOYEES
;

SELECT DISTINCT A.EMPLOYEE_ID 
FROM EMPLOYEES A, EMPLOYEES B
WHERE A.EMPLOYEE_ID=B.MANAGER_ID (+)
AND B.EMPLOYEE_ID IS NULL
ORDER BY A.EMPLOYEE_ID