-- 
CREATE SEQUENCE TEST_SEQ
INCREMENT BY 1
START WITH 10;

-- 
--CURRVAL ٷ  Ұ
SELECT TEST_SEQ.CURRVAL
FROM DUAL;

--Ѱ    ö
SELECT TEST_SEQ.NEXTVAL
FROM DUAL;
      
--  ö  ϴ (̺ CONNECT BY)
SELECT *
FROM DUAL
CONNECT BY LEVEL <= 3;

--NEXTVAL 
SELECT TEST_SEQ.NEXTVAL
FROM DUAL
CONNECT BY LEVEL <= 3;

--CURVAL 
SELECT TEST_SEQ.CURRVAL
FROM DUAL
CONNECT BY LEVEL <= 3;

--VIEW SELECT
CREATE VIEW UV_TEST_01
AS
SELECT TEST_SEQ.NEXTVAL
FROM DUAL;
      
--DISTINCT 
SELECT DISTINCT TEST_SEQ.NEXTVAL
FROM DUAL;

--GROUP BY   
SELECT JOB_ID, TEST_SEQ.NEXTVAL
FROM EMPLOYEES
GROUP BY JOB_ID;

--ORDER BY   
SELECT JOB_ID, TEST_SEQ.NEXTVAL
FROM EMPLOYEES
ORDER BY JOB_ID;

--SELECT  
SELECT *
FROM EMPLOYEES
WHERE JOB_ID = (SELECT TEST_SEQ.NEXTVAL FROM DUAL);

SELECT *
FROM EMPLOYEES A, (SELECT TEST_SEQ.NEXTVAL AS NXT_VAL FROM DUAL) B
WHERE JOB_ID = NXT_VAL;

SELECT JOB_ID, (SELECT TEST_SEQ.NEXTVAL AS NXT_VAL FROM DUAL)
FROM EMPLOYEES;

--UPDATE  
UPDATE EMPLOYEES SET JOB_ID = (SELECT TEST_SEQ.NEXTVAL FROM DUAL);

UPDATE EMPLOYEES SET JOB_ID = 'CCC'
WHERE JOB_ID = (SELECT TEST_SEQ.NEXTVAL FROM DUAL);

--DELETE  
DELETE FROM EMPLOYEES
WHERE JOB_ID = (SELECT TEST_SEQ.NEXTVAL FROM DUAL);

--̺    Ұ(12c  )
CREATE TABLE TB_TEST_01 (
  KEY_01  NUMBER  DEFAULT TEST_SEQ.NEXTVAL,
  COL_01  NUMBER
);

INSERT INTO TB_TEST_01 (COL_01)
VALUES (100);

SELECT *
FROM TB_TEST_01;

--̺    Ұ
DROP TABLE TB_TEST_01;

CREATE TABLE TB_TEST_01 (
  KEY_01  NUMBER
);

ALTER TABLE TB_TEST_01
ADD COL_01 NUMBER DEFAULT TEST_SEQ.NEXTVAL;

INSERT INTO TB_TEST_01 (KEY_01)
VALUES (10);

SELECT *
FROM TB_TEST_01;

-- 
SELECT TEST_SEQ.CURRVAL FROM DUAL;

ALTER SEQUENCE TEST_SEQ
INCREMENT BY 3;

SELECT TEST_SEQ.NEXTVAL FROM DUAL;

-- 
DROP SEQUENCE TEST_SEQ;

