--Ϲ 
--106
SELECT COUNT(*)
FROM EMPLOYEES A
JOIN DEPARTMENTS B ON A.DEPARTMENT_ID = B.DEPARTMENT_ID;

--LEFT OUTER JOIN
--107
SELECT COUNT(*)
FROM EMPLOYEES A
LEFT JOIN DEPARTMENTS B ON A.DEPARTMENT_ID = B.DEPARTMENT_ID;

--
SELECT EMPLOYEE_ID, FIRST_NAME, A.DEPARTMENT_ID, B.DEPARTMENT_ID, DEPARTMENT_NAME
FROM EMPLOYEES A
LEFT OUTER JOIN DEPARTMENTS B ON A.DEPARTMENT_ID = B.DEPARTMENT_ID
ORDER BY DEPARTMENT_NAME NULLS FIRST;

SELECT EMPLOYEE_ID, FIRST_NAME, A.DEPARTMENT_ID, B.DEPARTMENT_ID, DEPARTMENT_NAME
 FROM EMPLOYEES A, DEPARTMENTS B
WHERE A.DEPARTMENT_ID = B.DEPARTMENT_ID (+)
ORDER BY DEPARTMENT_NAME NULLS FIRST;

--RIGHT OUTER JOIN
--122
SELECT COUNT(*)
FROM EMPLOYEES A
RIGHT OUTER JOIN DEPARTMENTS B ON A.DEPARTMENT_ID = B.DEPARTMENT_ID;

--
SELECT EMPLOYEE_ID, FIRST_NAME, A.DEPARTMENT_ID, B.DEPARTMENT_ID, DEPARTMENT_NAME
FROM EMPLOYEES A
RIGHT OUTER JOIN DEPARTMENTS B ON A.DEPARTMENT_ID = B.DEPARTMENT_ID
ORDER BY EMPLOYEE_ID NULLS FIRST;

SELECT EMPLOYEE_ID, FIRST_NAME, A.DEPARTMENT_ID, B.DEPARTMENT_ID, DEPARTMENT_NAME
 FROM EMPLOYEES A, DEPARTMENTS B
WHERE A.DEPARTMENT_ID (+) = B.DEPARTMENT_ID
ORDER BY EMPLOYEE_ID NULLS FIRST;

--FULL OUTER JOIN
--123
SELECT COUNT(*)
FROM EMPLOYEES A
FULL OUTER JOIN DEPARTMENTS B ON A.DEPARTMENT_ID = B.DEPARTMENT_ID;

--
SELECT EMPLOYEE_ID, FIRST_NAME, A.DEPARTMENT_ID, B.DEPARTMENT_ID, DEPARTMENT_NAME
FROM EMPLOYEES A
FULL OUTER JOIN DEPARTMENTS B ON A.DEPARTMENT_ID = B.DEPARTMENT_ID
ORDER BY DEPARTMENT_NAME NULLS FIRST, EMPLOYEE_ID NULLS FIRST;

--
SELECT EMPLOYEE_ID, FIRST_NAME, A.DEPARTMENT_ID, B.DEPARTMENT_ID, DEPARTMENT_NAME
FROM EMPLOYEES A, DEPARTMENTS B
WHERE A.DEPARTMENT_ID (+) = B.DEPARTMENT_ID (+);

SELECT EMPLOYEE_ID, FIRST_NAME, A.DEPARTMENT_ID, B.DEPARTMENT_ID, DEPARTMENT_NAME
FROM EMPLOYEES A, DEPARTMENTS B
WHERE A.DEPARTMENT_ID = B.DEPARTMENT_ID (+)
UNION
SELECT EMPLOYEE_ID, FIRST_NAME, A.DEPARTMENT_ID, B.DEPARTMENT_ID, DEPARTMENT_NAME
FROM EMPLOYEES A, DEPARTMENTS B
WHERE A.DEPARTMENT_ID (+) = B.DEPARTMENT_ID
ORDER BY DEPARTMENT_NAME NULLS FIRST, EMPLOYEE_ID NULLS FIRST;

--SELF JOIN
SELECT A.EMPLOYEE_ID, A.FIRST_NAME, A.MANAGER_ID, B.EMPLOYEE_ID, B.FIRST_NAME, B.MANAGER_ID
FROM EMPLOYEES A, EMPLOYEES B
WHERE A.MANAGER_ID = B.EMPLOYEE_ID;

SELECT A.EMPLOYEE_ID, A.FIRST_NAME, A.MANAGER_ID
FROM EMPLOYEES A
START WITH A.MANAGER_ID IS NOT NULL
CONNECT BY PRIOR A.MANAGER_ID = A.EMPLOYEE_ID;