--Ϲ 
SELECT A.EMPLOYEE_ID, A.FIRST_NAME, A.SALARY, A.MANAGER_ID, B.FIRST_NAME AS MANAGER_NAME
FROM EMPLOYEES A, EMPLOYEES B
WHERE A.MANAGER_ID = B.EMPLOYEE_ID (+)
ORDER BY EMPLOYEE_ID;

-- ()
SELECT LEVEL, A.EMPLOYEE_ID, A.FIRST_NAME, A.SALARY, A.MANAGER_ID, B.FIRST_NAME AS MANAGER_NAME
FROM EMPLOYEES A, EMPLOYEES B
WHERE A.MANAGER_ID = B.EMPLOYEE_ID (+)
CONNECT BY A.MANAGER_ID = A.EMPLOYEE_ID
ORDER BY EMPLOYEE_ID;

-- (ٴܰ)
SELECT LEVEL, A.EMPLOYEE_ID, A.FIRST_NAME, A.SALARY, A.MANAGER_ID, B.FIRST_NAME AS MANAGER_NAME
FROM EMPLOYEES A, EMPLOYEES B
WHERE A.MANAGER_ID = B.EMPLOYEE_ID (+)
CONNECT BY A.MANAGER_ID = PRIOR  A.EMPLOYEE_ID;
--order by employee_id;

--ٴܰ  -> 
SELECT LEVEL, A.EMPLOYEE_ID, A.FIRST_NAME, A.SALARY, A.MANAGER_ID, B.FIRST_NAME AS MANAGER_NAME
FROM EMPLOYEES A, EMPLOYEES B
WHERE A.MANAGER_ID = B.EMPLOYEE_ID (+)
AND LEVEL = 1
CONNECT BY PRIOR A.MANAGER_ID = A.EMPLOYEE_ID;
--order by employee_id;

--ٴܰ (ORDER BY)
SELECT LEVEL, A.EMPLOYEE_ID, A.FIRST_NAME, A.SALARY, A.MANAGER_ID, B.FIRST_NAME AS MANAGER_NAME
FROM EMPLOYEES A, EMPLOYEES B
WHERE A.MANAGER_ID = B.EMPLOYEE_ID (+)
CONNECT BY PRIOR A.MANAGER_ID = A.EMPLOYEE_ID
ORDER BY FIRST_NAME;

--ٴܰ (ORDER SIBLINGS BY)
SELECT LEVEL, A.EMPLOYEE_ID, A.FIRST_NAME, A.SALARY, A.MANAGER_ID, B.FIRST_NAME AS MANAGER_NAME
FROM EMPLOYEES A, EMPLOYEES B
WHERE A.MANAGER_ID = B.EMPLOYEE_ID (+)
CONNECT BY A.MANAGER_ID = PRIOR A.EMPLOYEE_ID
ORDER SIBLINGS BY FIRST_NAME;

--ٴܰ ()
SELECT LEVEL, A.EMPLOYEE_ID, A.FIRST_NAME, A.SALARY, A.MANAGER_ID, B.FIRST_NAME AS MANAGER_NAME
FROM EMPLOYEES A, EMPLOYEES B
WHERE A.MANAGER_ID = B.EMPLOYEE_ID (+)
CONNECT BY PRIOR A.MANAGER_ID = A.EMPLOYEE_ID;

--ٴܰ (-ֱ)
SELECT LEVEL, A.EMPLOYEE_ID, A.FIRST_NAME, A.SALARY, A.MANAGER_ID, B.FIRST_NAME AS MANAGER_NAME
FROM EMPLOYEES A, EMPLOYEES B
WHERE A.MANAGER_ID = B.EMPLOYEE_ID (+)
START WITH a.manager_id is not null
CONNECT BY PRIOR A.MANAGER_ID = A.EMPLOYEE_ID;

--ٴܰ ()
SELECT LEVEL, A.EMPLOYEE_ID, A.FIRST_NAME, A.SALARY, A.MANAGER_ID, B.FIRST_NAME AS MANAGER_NAME
FROM EMPLOYEES A, EMPLOYEES B
WHERE A.MANAGER_ID = B.EMPLOYEE_ID (+)
START WITH a.manager_id is not null
CONNECT BY A.MANAGER_ID =  PRIOR A.EMPLOYEE_ID;

--ٴܰ (-)
SELECT LEVEL, A.EMPLOYEE_ID, A.FIRST_NAME, A.SALARY, A.MANAGER_ID, B.FIRST_NAME AS MANAGER_NAME
FROM EMPLOYEES A, EMPLOYEES B
WHERE A.MANAGER_ID = B.EMPLOYEE_ID (+)
START WITH a.manager_id is not null
CONNECT BY A.MANAGER_ID =  PRIOR A.EMPLOYEE_ID
ORDER SIBLINGS BY A.SALARY DESC;


-->     ǥϱ
--
SELECT DEPARTMENT_ID, SUM(SALARY)
FROM EMPLOYEES
GROUP BY DEPARTMENT_ID;

--
SELECT DISTINCT FIRST_NAME AS NAME
FROM EMPLOYEES
WHERE FIRST_NAME IN ('Lex', 'Neena', 'Steven')
ORDER BY NAME;

--DECODE Ǵ CASE  ̿Ͽ ÷ и
--DECODE
SELECT DECODE(NAME, 'Lex', NAME, '') AS NAME1
     , DECODE(NAME, 'Neena', NAME, '') AS NAME2
     , DECODE(NAME, 'Steven', NAME, '') AS NAME3
FROM
(
    SELECT DISTINCT FIRST_NAME AS NAME
    FROM EMPLOYEES
    WHERE FIRST_NAME IN ('Lex', 'Neena', 'Steven')
    ORDER BY NAME
);

--CASE
SELECT CASE WHEN NAME = 'Lex' THEN NAME ELSE '' END AS NAME1
     , CASE WHEN NAME = 'Neena' THEN NAME ELSE '' END AS NAME2
     , CASE WHEN NAME = 'Steven' THEN NAME ELSE '' END AS NAME3
FROM
(
    SELECT DISTINCT FIRST_NAME AS NAME
    FROM EMPLOYEES
    WHERE FIRST_NAME IN ('Lex', 'Neena', 'Steven')
    ORDER BY NAME
);

--׷ Լ ̿Ͽ   ϳ  ٲش.
SELECT MAX(NAME1) || ', ' || MAX(NAME2) || ', '|| MAX(NAME3) AS NAME 
FROM
(
    SELECT CASE WHEN NAME = 'Lex' THEN NAME ELSE '' END AS NAME1
         , CASE WHEN NAME = 'Neena' THEN NAME ELSE '' END AS NAME2
         , CASE WHEN NAME = 'Steven' THEN NAME ELSE '' END AS NAME3
    FROM
    (
        SELECT DISTINCT FIRST_NAME AS NAME
        FROM EMPLOYEES
        WHERE FIRST_NAME IN ('Lex', 'Neena', 'Steven')
        ORDER BY NAME
    )
);

--, ÷ Ǽ ƴ°쿡 밡(WM_CONCAT Ǵ LISTAGG Լ )

-->WM_CONCATԼ(11g  밡, 12c  Ұ)
SELECT WMSYS.WM_CONCAT(NAME) AS NAME
FROM 
(
    SELECT DISTINCT FIRST_NAME AS NAME
    FROM EMPLOYEES
    WHERE FIRST_NAME IN ('Lex', 'Neena', 'Steven')
    ORDER BY NAME
); 

--> 11g  ϴ LISTAGG Լ (11g  4000byte   ߻)
SELECT LISTAGG(NAME, ', ') WITHIN GROUP (ORDER BY NAME) AS NAME
FROM 
(
    SELECT DISTINCT FIRST_NAME AS NAME
    FROM EMPLOYEES
    WHERE FIRST_NAME IN ('Lex', 'Neena', 'Steven')
    ORDER BY NAME
); 

--> XMLAGG  (10g 밡 - 4000byte ̻ ϳ ɿ  ߻)
SELECT SUBSTR(XMLAGG(XMLELEMENT(IMSI, ', ', NAME) ORDER BY NAME).Extract('//text()'), 2) AS NAME
FROM 
(
    SELECT DISTINCT FIRST_NAME AS NAME
    FROM EMPLOYEES
    WHERE FIRST_NAME IN ('Lex', 'Neena', 'Steven')
    ORDER BY NAME
); 


-->  Լ  ϱ
--  (SYS_CONNECT_BY_PATH Ȯ)
SELECT SYS_CONNECT_BY_PATH(NAME, ', '), NAME
FROM
(
    SELECT ROWNUM AS ROW_ID, ROWNUM - 1 AS P_ROW_ID, NAME
    FROM
    (
        SELECT DISTINCT FIRST_NAME AS NAME
        FROM EMPLOYEES
        WHERE FIRST_NAME IN ('Lex', 'Neena', 'Steven')
        ORDER BY NAME
    )
)
CONNECT BY PRIOR ROW_ID = P_ROW_ID;

--  (SYS_CONNECT_BY_PATH Ȯ- ο)
SELECT SYS_CONNECT_BY_PATH(NAME, ', '), NAME
FROM
(
    SELECT ROWNUM AS ROW_ID, ROWNUM - 1 AS P_ROW_ID, NAME
    FROM
    (
        SELECT DISTINCT FIRST_NAME AS NAME
        FROM EMPLOYEES
        WHERE FIRST_NAME IN ('Lex', 'Neena', 'Steven')
        ORDER BY NAME
    )
)
START WITH ROW_ID = 1
CONNECT BY PRIOR ROW_ID = P_ROW_ID;

--׷Լ ٷ ٲٱ
SELECT MAX(SYS_CONNECT_BY_PATH(NAME, ', ')) AS NAME
FROM
(
    SELECT ROWNUM AS ROWCNT, NAME
    FROM
    (
        SELECT DISTINCT FIRST_NAME AS NAME
        FROM EMPLOYEES
        WHERE FIRST_NAME IN ('Lex', 'Neena', 'Steven')
        ORDER BY NAME
    )
)
START WITH ROWCNT = 1
CONNECT BY PRIOR ROWCNT = ROWCNT-1;

--ϴ    ߶󳻱
SELECT SUBSTR(MAX(SYS_CONNECT_BY_PATH(NAME, ', ')), 2) AS NAME
FROM
(
    SELECT ROWNUM AS ROWCNT, NAME
    FROM
    (
        SELECT DISTINCT FIRST_NAME AS NAME
        FROM EMPLOYEES
        WHERE FIRST_NAME IN ('Lex', 'Neena', 'Steven')
        ORDER BY NAME
    )
)
START WITH ROWCNT = 1
CONNECT BY PRIOR ROWCNT = ROWCNT-1;

-- ׷ ϱ
--0.LISTAGG 
SELECT LISTAGG(FIRST_NAME, ', ') WITHIN GROUP (ORDER BY FIRST_NAME) AS NAME
FROM EMPLOYEES
GROUP BY MANAGER_ID
ORDER BY MANAGER_ID NULLS FIRST;

--1.⺻ ϱ
SELECT MANAGER_ID, FIRST_NAME
FROM EMPLOYEES
ORDER BY MANAGER_ID NULLS FIRST;

--2.ROW_NUMBER()  Լ ̿Ͽ ROWCNT Ͽ 
SELECT ROW_NUMBER() OVER(PARTITION BY MANAGER_ID ORDER BY FIRST_NAME) AS ROWCNT, MANAGER_ID, FIRST_NAME AS NAME
FROM
(
    SELECT MANAGER_ID, FIRST_NAME
    FROM EMPLOYEES
);

--2. Լ  ROWCNT Ͽ 
SELECT ROWNUM - CNT AS ROWCNT, MANAGER_ID, FIRST_NAME AS NAME
FROM
(
    SELECT MANAGER_ID, FIRST_NAME, (SELECT COUNT(*) FROM EMPLOYEES B WHERE NVL(B.MANAGER_ID, 0) < NVL(A.MANAGER_ID, 0)) AS CNT
    FROM EMPLOYEES A
    ORDER BY MANAGER_ID NULLS FIRST, FIRST_NAME
);

--3. ϱ
SELECT LEVEL, ROWCNT, MANAGER_ID, NAME, SYS_CONNECT_BY_PATH(NAME, ',')
FROM
(
    SELECT ROWNUM - CNT AS ROWCNT, MANAGER_ID, FIRST_NAME AS NAME
    FROM
    (
        SELECT MANAGER_ID, FIRST_NAME, (SELECT COUNT(*) FROM EMPLOYEES B WHERE NVL(B.MANAGER_ID, 0) < NVL(A.MANAGER_ID, 0)) AS CNT
        FROM EMPLOYEES A
        ORDER BY MANAGER_ID NULLS FIRST, FIRST_NAME
    )
)
START WITH ROWCNT = 1
CONNECT BY PRIOR ROWCNT = ROWCNT -1 AND PRIOR MANAGER_ID = MANAGER_ID;


--4.ϴ  (׷ Լ ū ϱ)
SELECT MANAGER_ID, MAX(SYS_CONNECT_BY_PATH(NAME, ','))
FROM
(
    SELECT ROWNUM - CNT AS ROWCNT, MANAGER_ID, FIRST_NAME AS NAME
    FROM
    (
        SELECT MANAGER_ID, FIRST_NAME, (SELECT COUNT(*) FROM EMPLOYEES B WHERE NVL(B.MANAGER_ID, 0) < NVL(A.MANAGER_ID, 0)) AS CNT
        FROM EMPLOYEES A
        ORDER BY MANAGER_ID NULLS FIRST, FIRST_NAME
    )
)
START WITH ROWCNT = 1
CONNECT BY PRIOR ROWCNT = ROWCNT -1 AND PRIOR MANAGER_ID = MANAGER_ID
GROUP BY MANAGER_ID;

--5.ϴ  (SUBSTR )
SELECT MANAGER_ID, SUBSTR(MAX(SYS_CONNECT_BY_PATH(NAME, ',')), 2) AS NAME
FROM
(
    SELECT ROWNUM - CNT AS ROWCNT, MANAGER_ID, FIRST_NAME AS NAME
    FROM
    (
        SELECT MANAGER_ID, FIRST_NAME, (SELECT COUNT(*) FROM EMPLOYEES B WHERE NVL(B.MANAGER_ID, 0) < NVL(A.MANAGER_ID, 0)) AS CNT
        FROM EMPLOYEES A
        ORDER BY MANAGER_ID NULLS FIRST, FIRST_NAME
    )
)
START WITH ROWCNT = 1
CONNECT BY PRIOR ROWCNT = ROWCNT -1 AND PRIOR MANAGER_ID = MANAGER_ID
GROUP BY MANAGER_ID
ORDER BY MANAGER_ID NULLS FIRST;


--Լ ̿ 
--1. 
SELECT LEVEL, MANAGER_ID, FIRST_NAME, SYS_CONNECT_BY_PATH(FIRST_NAME, ', ')
FROM EMPLOYEES
CONNECT BY PRIOR MANAGER_ID = EMPLOYEE_ID;

--2.ϴ  
SELECT LEVEL, EMPLOYEE_ID, MANAGER_ID, SUBSTR(SYS_CONNECT_BY_PATH(FIRST_NAME, ', '), 2) AS NAME
FROM EMPLOYEES
CONNECT BY PRIOR MANAGER_ID = EMPLOYEE_ID;

--3. ֱ
SELECT EMPLOYEE_ID, MANAGER_ID, NAME
FROM
(
    SELECT LEVEL, EMPLOYEE_ID, MANAGER_ID, SUBSTR(SYS_CONNECT_BY_PATH(FIRST_NAME, ', '), 2) AS NAME
    FROM EMPLOYEES
    CONNECT BY PRIOR MANAGER_ID = EMPLOYEE_ID
)
WHERE MANAGER_ID IS NULL;

--4. Լ  
SELECT EMPLOYEE_ID, MANAGER_ID, NAME
FROM
(
    SELECT LEVEL, CONNECT_BY_ROOT(EMPLOYEE_ID) AS EMPLOYEE_ID, MANAGER_ID, SUBSTR(SYS_CONNECT_BY_PATH(FIRST_NAME, ', '), 2) AS NAME
    FROM EMPLOYEES
    CONNECT BY PRIOR MANAGER_ID = EMPLOYEE_ID
)
WHERE MANAGER_ID IS NULL;

-- Լ
SELECT LEVEL, EMPLOYEE_ID, MANAGER_ID, CONNECT_BY_ROOT(EMPLOYEE_ID) AS ROOT_ID, SUBSTR(SYS_CONNECT_BY_PATH(FIRST_NAME, ', '), 2) AS NAME, CONNECT_BY_ISCYCLE, CONNECT_BY_ISLEAF
FROM EMPLOYEES
CONNECT BY NOCYCLE PRIOR MANAGER_ID = EMPLOYEE_ID;

--ǽ (WHERE   Լ  )
SELECT LEVEL, EMPLOYEE_ID, MANAGER_ID, CONNECT BY ROOT(EMPLOYEE_ID) AS ROOT_ID, SUBSTR(SYS_CONNECT_BY_PATH(FIRST_NAME, ', '), 2) AS NAME, CONNECT_BY_ISCYCLE, CONNECT_BY_ISLEAF
FROM EMPLOYEES
WHERE CONNECT_BY_ISLEAF = 1
CONNECT BY NOCYCLE PRIOR MANAGER_ID = EMPLOYEE_ID

