--̺ 
CREATE TABLE TB_TEST01 (
  COL_01 VARCHAR2(10),
  COL_02 VARCHAR2(10),
  COL_03 VARCHAR2(10),
  COL_04 VARCHAR2(10)  
)
TABLESPACE TEST_TBS1;

--̺ : Į 
CREATE TABLE TB_VIRTURAL (
   REG_DATE        DATE,
   REAL_REG_DATE   DATE,
   DATE_CHA GENERATED ALWAYS
   AS (REAL_REG_DATE - REG_DATE) VIRTUAL
);

INSERT INTO TB_VIRTURAL(REG_DATE, REAL_REG_DATE)
VALUES (SYSDATE -7, SYSDATE);
     
INSERT INTO TB_VIRTURAL(REG_DATE, REAL_REG_DATE)
VALUES (SYSDATE -7, NULL);
     
SELECT *
FROM TB_VIRTURAL;



--⺻ ̺ ̽ 
CREATE TABLE TB_TEST02 (
  COL_01 VARCHAR2(10),
  COL_02 VARCHAR2(10),
  COL_03 VARCHAR2(10),
  COL_04 VARCHAR2(10)  
);
 

--̺Ǻ :   
CREATE TABLE TB_TEST03
AS 
SELECT *
FROM HR.JOBS;

--̺Ǻ :   
CREATE TABLE TB_TEST04
AS 
SELECT *
FROM HR.JOBS
WHERE 1 = 2;

--̺  : ̺ ̸ 
ALTER TABLE TB_TEST04 RENAME TO TB_TEST99;

--̺ : Į ߰
ALTER TABLE TB_TEST99
ADD COL_01 VARCHAR2(30);

--̺ : Į ߰
ALTER TABLE TB_TEST99
ADD (COL_02 VARCHAR2(30), COL_03 NUMBER(10));

--̺ : Į 
ALTER TABLE TB_TEST99
MODIFY COL_01 VARCHAR2(20);

--̺ : Į 
ALTER TABLE TB_TEST99
MODIFY (COL_02 VARCHAR2(20), COL_03 VARCHAR2(20));

--̺ : Į 
ALTER TABLE TB_TEST99
DROP COLUMN COL_01;

--̺ : Į 
ALTER TABLE TB_TEST99
DROP (COL_02, COL_03);

--̺ :Į 
ALTER TABLE TB_TEST99
RENAME COLUMN JOB_ID TO JOB_ID1;

--̺ :  Į 
ALTER TABLE TB_TEST99
SET UNUSED COLUMN JOB_TITLE;

--̺ :  Į 
ALTER TABLE TB_TEST99
SET UNUSED (MIN_SALARY, MAX_SALARY);

--Į  Ȯ
SELECT *
FROM TB_TEST99;

SELECT *
FROM USER_UNUSED_COL_TABS
WHERE TABLE_NAME  = 'TB_TEST99';

-- Ͽ  Ȯ 
ALTER TABLE TB_TEST99
DROP UNUSED COLUMNS;

-- ͽƮ Ȯ
SELECT *
FROM USER_EXTENTS
WHERE SEGMENT_NAME = 'TB_TEST99';

INSERT INTO TB_TEST99 (JOB_ID1)
VALUES ('01');

COMMIT;

-- ͽƮ Ҵ
ALTER TABLE TB_TEST99
ALLOCATE EXTENT (SIZE 1M);


-- ͽƮ 
ALTER TABLE TB_TEST99
DEALLOCATE UNUSED;

--̺  : Ϲ
DROP TABLE TB_TEST99;


--  Ȯ
DROP TABLE JOBS;


--  
--1. ̺ 
CREATE TABLE JOBS_BK
AS
SELECT *
FROM JOBS;

CREATE TABLE EMPLOYEES_BK
AS
SELECT *
FROM EMPLOYEES;

--⺻Ű 
ALTER TABLE JOBS_BK
ADD CONSTRAINT PK_JOBS_BK PRIMARY KEY (JOB_ID);

ALTER TABLE EMPLOYEES_BK
ADD CONSTRAINT PK_EMPLOYEES_BK PRIMARY KEY (EMPLOYEE_ID);

-- 
ALTER TABLE EMPLOYEES_BK
ADD CONSTRAINT EMP_JOB_BK_FK
    FOREIGN KEY (JOB_ID) 
    REFERENCES JOBS_BK (JOB_ID);
    
--  Ȯ
DROP TABLE JOBS_BK;

--   ̺  
DROP TABLE JOBS_BK CASCADE CONSTRAINTS;

-- Ȯ :  ̺
SELECT *
FROM EMPLOYEES_BK;

--  Ȯ
SELECT *
FROM USER_CONSTRAINTS
WHERE CONSTRAINT_NAME = 'EMP_JOB_BK_FK';

--Ŭ   Ȯ
--1   
PURGE RECYCLEBIN;

--2. DROP  
SELECT *
FROM TB_TEST03;

DROP TABLE TB_TEST03;

DROP TABLE TB_TEST02;

--3. PURGE ɼ 
DROP TABLE TB_TEST01 PURGE;

--4. PURGE   (DROP TABLE   ̺  )
PURGE TABLE TB_TEST02;

--5. 뿡 
FLASHBACK TABLE TB_TEST03 TO BEFORE DROP;

--6. ̺ Ȯ
SELECT *
FROM TB_TEST03;
