-- Է
--Է ̺ 
DROP TABLE TB_TEST_01 PURGE;

CREATE TABLE TB_TEST_01 (
    KEY_01  VARCHAR2(10),
    COL_01  VARCHAR2(100)    
);

--1.̺  Է
--Ϲ
INSERT INTO TB_TEST_01 (KEY_01, COL_01)
VALUES ('AAA', 'TEST_AAA');

--Į 
INSERT INTO TB_TEST_01
VALUES ('BBB', 'TEST_BBB');

-- ٲٱ
INSERT INTO TB_TEST_01 (COL_01, KEY_01)
VALUES ('TEST_CCC', 'CCC');

--Է° 
INSERT INTO TB_TEST_01 (KEY_01)
VALUES ('DDD');

--Ÿ ȸ
SELECT *
FROM TB_TEST_01;

--
ROLLBACK;

--2.̺  Է
--Ϲ
INSERT INTO TB_TEST_01 (KEY_01, COL_01)
SELECT JOB_ID, JOB_TITLE 
FROM JOBS
WHERE JOB_ID LIKE 'AD%';

--ٲٱ
INSERT INTO TB_TEST_01 (COL_01, KEY_01)
SELECT JOB_TITLE, JOB_ID  
FROM JOBS
WHERE JOB_ID LIKE 'SA%';

--Ÿ ȸ
SELECT *
FROM TB_TEST_01;

--
ROLLBACK;


--3.̺  Է
--̺ 
DROP TABLE TB_TEST_01 PURGE;

CREATE TABLE TB_TEST_01 (
    KEY_01  VARCHAR2(10),
    COL_01  VARCHAR2(100)    
);

DROP TABLE TB_TEST_02 PURGE;

CREATE TABLE TB_TEST_02 (
    KEY_01  VARCHAR2(10),
    KEY_02  VARCHAR2(10),
    COL_01  VARCHAR2(100),
    COL_02  VARCHAR2(100)    
);

-- Է(Ϲ)
INSERT ALL
INTO TB_TEST_01 (KEY_01, COL_01) VALUES (DEPARTMENT_ID, DEPARTMENT_NAME)
INTO TB_TEST_02 (KEY_01, KEY_02, COL_01, COL_02) VALUES (DEPARTMENT_ID, EMPLOYEE_ID, FIRST_NAME, LAST_NAME)
SELECT A.DEPARTMENT_ID, A.DEPARTMENT_NAME, B.EMPLOYEE_ID, B.FIRST_NAME, B.LAST_NAME
FROM DEPARTMENTS A, EMPLOYEES B
WHERE A.DEPARTMENT_ID = B.DEPARTMENT_ID;

-- ȸ
SELECT *
FROM TB_TEST_01;

-- ȸ
SELECT *
FROM TB_TEST_02;

--
ROLLBACK;

--Ű ϴ ̺
DROP TABLE TB_TEST_01 PURGE;

CREATE TABLE TB_TEST_01 (
    KEY_01  VARCHAR2(10),
    COL_01  VARCHAR2(100),
    CONSTRAINT PK_TB_TEST_01 PRIMARY KEY (KEY_01)    
);

DROP TABLE TB_TEST_02 PURGE;

CREATE TABLE TB_TEST_02 (
    KEY_01  VARCHAR2(10),
    KEY_02  VARCHAR2(10),
    COL_01  VARCHAR2(100),
    COL_02  VARCHAR2(100),
    CONSTRAINT PK_TB_TEST_02 PRIMARY KEY (KEY_01, KEY_02)    
);

-- Է(Ϲ) - Ἲ  
INSERT ALL
INTO TB_TEST_01 (KEY_01, COL_01) VALUES (DEPARTMENT_ID, DEPARTMENT_NAME)
INTO TB_TEST_02 (KEY_01, KEY_02, COL_01, COL_02) VALUES (DEPARTMENT_ID, EMPLOYEE_ID, FIRST_NAME, LAST_NAME)
SELECT A.DEPARTMENT_ID, A.DEPARTMENT_NAME, B.EMPLOYEE_ID, B.FIRST_NAME, B.LAST_NAME
FROM DEPARTMENTS A, EMPLOYEES B
WHERE A.DEPARTMENT_ID = B.DEPARTMENT_ID;

-- Ἲ   ߾ Է
INSERT ALL
WHEN ROW_NUM = 1 THEN
INTO TB_TEST_01 (KEY_01, COL_01) VALUES (DEPARTMENT_ID, DEPARTMENT_NAME)
WHEN 1 = 1 THEN
INTO TB_TEST_02 (KEY_01, KEY_02, COL_01, COL_02) VALUES (DEPARTMENT_ID, EMPLOYEE_ID, FIRST_NAME, LAST_NAME)
SELECT A.DEPARTMENT_ID, A.DEPARTMENT_NAME, B.EMPLOYEE_ID, B.FIRST_NAME, B.LAST_NAME, ROW_NUMBER() OVER (PARTITION BY A.DEPARTMENT_ID ORDER BY A.DEPARTMENT_ID) AS ROW_NUM
FROM DEPARTMENTS A, EMPLOYEES B
WHERE A.DEPARTMENT_ID = B.DEPARTMENT_ID;

-- ȸ
SELECT *
FROM TB_TEST_01;

-- ȸ
SELECT *
FROM TB_TEST_02;

--
ROLLBACK;

--̺ ǿ ° Է
--̺ 
--Ű ϴ ̺
DROP TABLE TB_TEST_01 PURGE;

CREATE TABLE TB_TEST_01 (
    KEY_01  VARCHAR2(10),
    COL_01  VARCHAR2(100),
    CONSTRAINT PK_TB_TEST_01 PRIMARY KEY (KEY_01)    
);

DROP TABLE TB_TEST_02 PURGE;

CREATE TABLE TB_TEST_02 (
    KEY_02  VARCHAR2(10),
    COL_02  VARCHAR2(100),
    CONSTRAINT PK_TB_TEST_02 PRIMARY KEY (KEY_02)    
);


DROP TABLE TB_TEST_03 PURGE;

CREATE TABLE TB_TEST_03 (
    KEY_03  VARCHAR2(10),
    COL_03  VARCHAR2(100),
    CONSTRAINT PK_TB_TEST_03 PRIMARY KEY (KEY_03)    
);

--  Է
INSERT ALL
WHEN KEY_03 LIKE 'AD%' THEN 
INTO TB_TEST_01 (KEY_01, COL_01) VALUES (KEY_03, JOB_TITLE)
WHEN KEY_03 LIKE 'SA%'  THEN
INTO TB_TEST_02 (KEY_02, COL_02) VALUES (KEY_03, JOB_TITLE)
ELSE
INTO TB_TEST_03 (KEY_03, COL_03) VALUES (KEY_03, JOB_TITLE)
SELECT JOB_ID AS KEY_03, JOB_TITLE
FROM JOBS;

-- ȸ
SELECT *
FROM TB_TEST_01;

-- ȸ
SELECT *
FROM TB_TEST_02;

-- ȸ
SELECT *
FROM TB_TEST_03;

ROLLBACK;


-- 
--   ̺ 
DROP TABLE TB_JOBS_BK PURGE;

CREATE TABLE TB_JOBS_BK
AS
SELECT *
FROM JOBS;

SELECT *
FROM TB_JOBS_BK;

-- ̺ Į 
UPDATE TB_JOBS_BK SET MIN_SALARY = 0
WHERE JOB_ID LIKE 'AD_%';

ROLLBACK;

-- ̺ Į 
UPDATE TB_JOBS_BK SET MIN_SALARY = NULL, MAX_SALARY = NULL
WHERE JOB_ID LIKE 'AD_%';

COMMIT;

SELECT *
FROM TB_JOBS_BK
WHERE JOB_ID LIKE 'AD_%';

--NVAL, DECODE 
UPDATE TB_JOBS_BK SET MIN_SALARY = NVL(MIN_SALARY, 0), MAX_SALARY = DECODE(MAX_SALARY, NULL, 2, 0)
WHERE JOB_ID LIKE 'AD_%';

--NVL2, CASE 
UPDATE TB_JOBS_BK SET MIN_SALARY = CASE WHEN MIN_SALARY IS NULL THEN 1 ELSE 0 END
                    , MAX_SALARY = CASE WHEN MAX_SALARY IS NULL THEN 2 ELSE 0 END
WHERE JOB_ID LIKE 'AD_%';

COMMIT;

--ٸ̺  ̺ 
UPDATE TB_JOBS_BK A SET (MIN_SALARY, MAX_SALARY) = (SELECT MIN_SALARY, MAX_SALARY 
                                                      FROM JOBS B
                                                     WHERE A.JOB_ID = B.JOB_ID)
WHERE JOB_ID LIKE 'AD_%';

SELECT *
FROM TB_JOBS_BK
WHERE JOB_ID LIKE 'AD_%';

COMMIT;

-- 
SELECT *
FROM TB_JOBS_BK
WHERE JOB_ID LIKE 'AD_%';

DELETE
FROM TB_JOBS_BK
WHERE JOB_ID LIKE 'AD_%';

ROLLBACK;

--ٸ̺   
DELETE
FROM TB_JOBS_BK
WHERE JOB_ID IN (SELECT JOB_ID FROM JOBS WHERE JOB_ID LIKE 'AD_%');

